<?php
namespace Backend\Controller;

use Backend\Controller\BackendController;
use Backend\Model\MemberModel;
use Backend\Model\UserLevelModel;
use Common\Model\RegionModel;
use Common\Respository\MemberRespository;

/**
 * 会员级别折扣管理
 * @author: Guopeng
 * @时间: 2017年11月27日11:13:29=
 */
class UserLevelController extends BackendController{
	
	/**
	 * 初始化仓储和模型
	 * @时间: 2017年11月27日11:13:33
	 * @author: Guopeng
	 */
	public function _initialize(){
		parent::_initialize();
		$this->model = new MemberModel();
		$this->respository = new MemberRespository($this->model);
	}
	
	/**会员级别折扣列表*/
	public function index(){
		$level = new UserLevelModel();
		$info = $level->get_product_discount();
		$region = new RegionModel();
		$user_level = $region->get_all_user_level_list();
		$discounts = WebSiteConfig(8);
		$this->assign([
			"product" => $info,
			'user_level' => $user_level,
			'discounts' => $discounts
		]);
		$this->display();
	}

	/**
	 * 添加会员级别
	 * @时间: 2017年11月27日11:12:22
	 * @author: Guopeng
	 */
	public function add_level(){
		$level = new UserLevelModel();
		$res = $level->add_level();
		if($res === false){
			$msg = $level->getError();
			if(IS_AJAX){
				$this->error($msg,"",true);
			}else{
				$this->error($msg);
			}
		}else{
			$msg = '添加成功！';
			if(IS_AJAX){
				$this->success($msg,"",true);
			}else{
				$this->success($msg);
			}
		}
	}

	/**
	 * 修改会员级别
	 * @时间: 2017年11月27日11:12:22
	 * @author: Guopeng
	 */
	public function edit_level(){
		$level = new UserLevelModel();
		$res = $level->edit_level();
		if($res === false){
			$msg = $level->getError();
			if(IS_AJAX){
				$this->error($msg,"",true);
			}else{
				$this->error($msg);
			}
		}else{
			$msg = '更新成功！';
			if(IS_AJAX){
				$this->success($msg,"",true);
			}else{
				$this->success($msg);
			}
		}
	}

	/**
	 * 删除会员级别
	 * @时间: 2017年11月27日11:12:22
	 * @author: Guopeng
	 */
	public function delete_level(){
		$level = new UserLevelModel();
		$res = $level->delete_level();
		if($res === false){
			$msg = $level->getError();
			if(IS_AJAX){
				$this->error($msg,"",true);
			}else{
				$this->error($msg);
			}
		}else{
			$msg = '删除成功！';
			if(IS_AJAX){
				$this->success($msg,"",true);
			}else{
				$this->success($msg);
			}
		}
	}

	/**
	 * 修改会员级别产品折扣
	 * @时间: 2017年11月27日11:12:22
	 * @author: Guopeng
	 */
	public function update_discount(){
		$level = new UserLevelModel();
		//更新操作
		$res = $level->update_p_discount();
		//返回结果
		if($res === false){
			$msg = $level->getError();
			if(IS_AJAX){
				$this->error($msg,"",true);
			}else{
				$this->error($msg);
			}
		}else{
			$msg = '更新成功！';
			if(IS_AJAX){
				$this->success($msg,"",true);
			}else{
				$this->success($msg);
			}
		}
	}

	/**
	 * 添加会员级别产品折扣
	 * @时间: 2019年2月19日10:03:52
	 * @author: Guopeng
	 */
	public function add_discount(){
		$level = new UserLevelModel();
		//更新操作
		$res = $level->add_p_discount();
		//返回结果
		if($res === false){
			$msg = $level->getError();
			if(IS_AJAX){
				$this->error($msg,"",true);
			}else{
				$this->error($msg);
			}
		}else{
			$msg = '添加成功！';
			if(IS_AJAX){
				$this->success($msg,"",true);
			}else{
				$this->success($msg);
			}
		}
	}
}
