<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2017/1/10
 * Time: 10:08
 */

namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\ClouddbModel;
use Frontend\Model\HelpModel;
use Frontend\Model\OrderModel;

class ClouddbController extends FrontendController{

    /**
     * 快云数据库产品信息页面
     */
    public function ClouddbShow(){
        $article = new HelpModel();
        $cpbz = $article->home_news("快云数据库");
        $czsc = $article->home_news("数据库");
        $bazn = $article->home_news("备案");
        $this->assign(['cpbz' => $cpbz,'czsc' => $czsc,'bazn' => $bazn]);
        $this->display("ClouddbShow");
    }

    /**
     * 快云数据库独享版购买页面
     */
    public function clouddbdx(){
        $this->display();
    }

    /**
     * 快云数据库分享版购买页面
     */
    public function clouddbgx(){
        $this->display();
    }

    /**
     * 获取列表数量和待续费业务数量
     * @date: 2017年4月11日 下午4:47:38
     * @author: Lyubo
     */
    public function state_count(){
        $clouddb = new ClouddbModel();
        $sum = $clouddb->cloudserver_stateCount(GD::PTYPE_CLOUD_DATABASE);
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 快云数据库价格
     * @data: 2016年11月25日 下午2:39:40
     * @author: Guopeng
     * @return price
     */
    public function buyPrice(){
        $data = request();
        $clouddb = new ClouddbModel();
        $price = $clouddb->getPrice($data);
        if($price !== false){
            $date['price'] = $price;
            $date["flag"] = true;
        }else{
            $date['price'] = $clouddb->getError();
            $date["flag"] = false;
        }
        $this->ajaxReturn($date);
    }

    /**
     * 快云数据库购买
     * @author: Guopeng
     * @param: variable
     * @return json code
     */
    public function clouddb_buy(){
        if(!session('?user_id')){
            if(IS_AJAX){
                $this->success("请先登录！",U('Login/login'),true);
            }else{
                redirect(U('Login/login'),0,'');die();
            }
        }
        $data = request();
        $clouddb = new ClouddbModel();
        $result = $clouddb->clouddb_order_buy($data);
        if($result){
            $url = U('order/orderlist',['state'=>'6']);
            $msg = '购买成功，您可以在[会员中心-我的订单]查看订单信息!';
            $this->success($msg,$url,3);
        }else{
            $msg = $clouddb->getError();
            $this->error($msg);
        }
    }

    /**
     * 快云数据库转正
     * @date: 2018年5月4日10:26:41
     * @author: gechangfen
     */
    public function clouddb_onformal(){
        //$this->_empty("不能转正！",1);die;
        if (! session('?user_id')) {
            redirect(U('Login/login'));die();
        }
        $cdb = new ClouddbModel();
        $data = request();
        $cdb_id = $data['clouddb_id'] + 0;
        $mid = session("user_id");
        if(IS_POST){
            $onformal_time = $data['service_time'];
            if(is_null($cdb_id) || !is_numeric($cdb_id) || strpos($cdb_id,".") != false){
                $msg = "业务编号为空或错误";
                $this->error($msg,U('clouddb/clouddblist'));
            }else{
                $result = $cdb->cdb_onformal($cdb_id,$mid,$onformal_time);
                $message = business_code($result);
                if($result == -1){
                    $this->success("快云数据库转正成功",U('clouddb/clouddblist'));
                }else{
                    $this->error($message,U('clouddb/clouddblist'));
                }
            }
        }else{
            if(empty($cdb_id)){
                $msg = "业务编号为空或错误！";
                $this->_empty($msg,1);die;
            }else{
                // 业务信息
                $cdb_info = $cdb->show_cdb_onformal($mid,$cdb_id);
                if($cdb_info <= 0){
                    $msg = business_code($cdb_info);
                    $this->_empty($msg,1);die;
                }else{
                    $this->assign($cdb_info);
                    $this->display();
                }
            }
        }
    }

    /**
     * 快云服务器开通
     * @author: Guopeng
     * @param: $order_id
     */
    public function clouddb_open(){

        if(!session('?user_id')){
            if(IS_AJAX){
                $this->success("请先登录！",U('Login/login'),true);
            }else{
                redirect(U('Login/login'),0,'');die();
            }
        }
        $clouddb = new ClouddbModel();
        $order = new OrderModel();
        $data = request();
        $user_id = session("user_id");
        $order_id = $data['order_id'] + 0;
        if(IS_POST){
            // 开通快云服务器
            $result = $clouddb->clouddb_open($order_id,$user_id,$data);
            if($result){
                $msg = "快云数据库业务正在队列开通,请到[会员中心]业务列表等待获取业务信息";
                $this->success($msg,U('clouddb/clouddblist'),true);
            }else{
                $message = $clouddb->getError();
                $this->error($message,U('order/orderlist',['state'=>'6']),true);
            }
        }else{
            //显示快云数据库开通页面
            // 获取订单信息
            $order_info = $order->order_find($order_id);

            if(empty($order_info)){
                $this->error('订单不存在',U('order/orderlist'));
            }
            if($order_info['user_id'] != $user_id){
                $this->error('该订单不属于当前会员!',U('order/orderlist'));
            }
            if($order_info['state'] != 6){
                $this->error('订单状态错误！',U('order/orderlist'));
            }

            $this->assign('order_info',$order_info);
            $this->display();
        }
    }

    /**
     * 获取用户所有快云数据库业务
     * @author: Guopeng
     */
    public function clouddblist(){
        if(!session('?user_id')){
            redirect(U('Login/login'),0,'');die();
        }

        $page = request()["page"] + 0;

		$keyword = request()['select'] ? request()["select"] : "";
        $clouddb = new ClouddbModel();
        $where = $clouddb->conver_par();
        $order = I("get.order");
        $pagnum=request()['pagnum'] ? request()["pagnum"] : "10";//每页显示条数
        $info = $clouddb->get_clouddb_business_list($where,$pagnum,$order,GD::PTYPE_CLOUD_DATABASE);
        $info['list'] = get_clouddb_config($info['list'],1);
        $Not_open = $clouddb->get_not_open($info['list'],5);
        $Not_uplevel = $clouddb->get_not_open($info['list'],6);

        if($page > 0 && isMobile() == 'phone'){
            if(empty($info['list'])){
                echo json_encode("last");
                die();
            }else{
                echo json_encode($info['list']);
                die();
            }
        }

        $this->assign([
			"count" => $info['count'],
			"page" => $info["page_show"],
			"info" => $info['list'],
            "pagnum"=>$pagnum,
			"not_open" => implode(",",$Not_open),
			"not_uplevel" => implode(",",$Not_uplevel),
			"keyword" => $keyword
		]);
        $this->display();
    }

    /**
     * 获取用户所有快云数据库业务
     * @author: Guopeng
     */
    public function clouddbrenew(){
        if(!session('?user_id')){
            redirect(U('Login/login'),0,'');die();
        }
		$keyword = request()['select'] ? request()["select"] : "";
        $clouddb = new ClouddbModel();
        $where = $clouddb->conver_par();
        $order = I("get.order");
        $info = $clouddb->get_clouddb_renew_list($where,10,$order,GD::PTYPE_CLOUD_DATABASE);
		$info['list'] = get_clouddb_config($info['list'],1);
        $Not_open = $clouddb->get_not_open($info['list'],5);
        $Not_uplevel = $clouddb->get_not_open($info['list'],6);
        $this->assign(["count" => $info['count'],"page" => $info["page_show"],"info" => $info['list'],"keyword" => $keyword]);
        $this->display();
    }

    /**
     * 修改备注
     * @author: Guopeng
     * @param: remark，business_id
     * @return boolean
     */
    public function remark(){
        $cloudserver = new ClouddbModel();
        $result = $cloudserver->remark_edit();
        if($result){
            $data = "ok";
            $this->ajaxReturn($data,'json');
        }else{
            $data = "fail";
            $this->ajaxReturn($data,'json');
        }
    }

    /**
     * 获取快云数据库开通进度
     * @author : Guopeng
     * @param : $clouddb_id,保存在主站的订单编号
     * @return  boolean
     */
    public function get_open_progress(){
        $clouddb = new ClouddbModel();
        $data = request();
        $clouddb_id = $data['clouddb_id'];
        if(is_null($clouddb_id) || !is_numeric($clouddb_id) || strpos($clouddb_id,".") != false){
            $msg = "业务编号为空或错误";
            $this->error($msg,"",true);
        }
        $result = $clouddb->get_business_info($clouddb_id);
        if($result){
            $msg = "业务开通成功";
            $this->success($msg,"",true);
        }elseif($result === 0){
            $this->error("",1,true);
        }else{
            $msg = $clouddb->getError();
            $this->error($msg,0,true);
        }
    }

    /**
     * 快云数据库续费业务
     * @author : Guopeng
     */
    public function clouddb_renewals(){
        $data = request();
        $user_id = session("user_id");
        $yw_id = $data["clouddb_id"] + 0;
        $clouddb = new ClouddbModel();
        $url = U('clouddb/clouddblist');
        if(IS_POST){
            if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
                $message = "业务编号为空或错误";
                $this->error($message,$url,true);
            }
            /*快云数据库续费*/
            $result = $clouddb->clouddb_renewals($user_id,$yw_id,$data);
            if($result == -1){
                $message = "快云数据库续费成功，您可以在[会员中心]快云数据库查看信息";
                $this->success($message,$url,true);
            }else{
                $message = business_code($result);
                $this->error($message,$url,true);
            }
        }else{
            if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
                $message = "业务编号为空或错误";
                $this->error($message,$url);
            }
            /*快云数据库续费业务信息显示*/
            $result = $clouddb->clouddb_renewals($user_id,$yw_id,'','get');
            if($result <= 0){
                $message = business_code($result);
                $this->error($message,$url);
            }
            $this->assign($result);
            $this->display();
        }
    }

    /**
     * 快云数据库升级业务
     * @author : Guopeng
     */
    public function clouddb_uplevel(){
        $data = request();
        $user_id = session("user_id");
        $yw_id = $data["clouddb_id"] + 0;
        $clouddb = new ClouddbModel();
        $url = U('clouddb/clouddblist');
        if(IS_POST){
            if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
                $message = "业务编号为空或错误";
                $this->error($message,$url);
            }
            /*快云数据库续费*/
            $result = $clouddb->clouddb_uplevel($user_id,$yw_id,$data);
            if($result == -1){
                $message = "快云数据库业务正在队列升级,请到[会员中心]业务列表等待获取业务信息";
                $this->success($message,$url);
            }else{
                $message = business_code($result);
                $this->error($message,$url);
            }
        }else{
            if(is_null($yw_id) || !is_numeric($yw_id) || strpos($yw_id,".") != false || $yw_id <= 0){
                $message = "业务编号为空或错误";
                $this->error($message,$url);
            }
            /*快云数据库续费业务信息显示*/
            $result = $clouddb->clouddb_uplevel($user_id,$yw_id,'','get');
            if($result <= 0){
                $message = business_code($result);
                $this->error($message,$url);
            }
			$peizhi = [
				1=>["cpu"=>1,"mem"=>256,"name"=>"1核256MB","conn"=>60,"iops"=>320],
				2=>["cpu"=>1,"mem"=>512,"name"=>"1核512MB","conn"=>100,"iops"=>500],
				3=>["cpu"=>1,"mem"=>1,"name"=>"1核1G","conn"=>300,"iops"=>800],
				4=>["cpu"=>2,"mem"=>1,"name"=>"2核1G","conn"=>400,"iops"=>800],
				5=>["cpu"=>2,"mem"=>2,"name"=>"2核2G","conn"=>600,"iops"=>1500],
				6=>["cpu"=>2,"mem"=>4,"name"=>"2核4G","conn"=>1200,"iops"=>3200],
				7=>["cpu"=>4,"mem"=>4,"name"=>"4核4G","conn"=>1200,"iops"=>3200],
				8=>["cpu"=>4,"mem"=>8,"name"=>"4核8G","conn"=>2000,"iops"=>7000],
				9=>["cpu"=>8,"mem"=>8,"name"=>"8核8G","conn"=>2000,"iops"=>7000],
				10=>["cpu"=>8,"mem"=>16,"name"=>"8核16G","conn"=>4000,"iops"=>8000],
				11=>["cpu"=>16,"mem"=>16,"name"=>"16核16G","conn"=>4000,"iops"=>8000],
				12=>["cpu"=>16,"mem"=>32,"name"=>"16核32G","conn"=>5000,"iops"=>12000],
				13=>["cpu"=>32,"mem"=>32,"name"=>"32核32G","conn"=>5000,"iops"=>12000],
			];
            $this->assign($result);
			$this->assign("peizhi",$peizhi);
            $this->display();
        }
    }

    /**
     * 获取快云数据库升级状态
     * @author : Guopeng
     * @param : $clouddb_id,保存在主站的订单编号
     * @return  boolean
     */
    public function get_uplevel_progress(){
        $clouddb = new ClouddbModel();
        $data = request();
        $user_id = session("user_id");
        $clouddb_id = $data['clouddb_id'];
        if(is_null($clouddb_id) || !is_numeric($clouddb_id) || strpos($clouddb_id,".") != false){
            $msg = "业务编号为空或错误";
            $this->error($msg,"",true);
        }
        $result = $clouddb->get_uplevel_progress($user_id,$clouddb_id);
        if($result){
            $msg = "业务升级成功";
            $this->success($msg,"",true);
        }elseif($result === 0){
            $this->error("",1,true);
        }else{
            $msg = $clouddb->getError();
            $this->error($msg,0,true);
        }
    }

    /**
     * 同步业务信息
     * @author: Guopeng
     * @param: $yw_id,$ptype
     * @return boolean
     */
    public function memberSync(){
        $data = request();
        $yw_id = $data['business_id'] + 0;
        $url = U('clouddb/clouddblist');
        $clouddb = new ClouddbModel();
        $clouddbRespository = new \Common\Respository\ClouddbBusinessRespository($clouddb);
        $result = $clouddbRespository->ClouddbBusinessSynchronizing($yw_id);
        if($result){
            $this->success("同步业务信息成功",$url,true);
        }else{
            $this->error("同步业务信息失败-".$clouddbRespository->model()->getError(),$url,true);
        }
    }

    /**
     * 批量同步业务信息
     * @date: 2018年4月16日17:07:09
     * @author: Guopeng
     * @param: $business_id,$ptype
     */
    public function SyncBatch(){
        $data = request();
        $yids = $data["yids"];
        $clouddb = new ClouddbModel();
        $clouddbRespository = new \Common\Respository\ClouddbBusinessRespository($clouddb);
        if(!is_array($yids)){
            $this->error("同步业务信息失败!","",true);
        }
        $all = $ok = $err = 0;
        foreach($yids as $yid){
            $all++;
            $info = $clouddb->clouddb_info($yid);
            if(!$info){
                $this->error("同步业务信息失败!","",true);
            }
            $yw_id = $info['business_id'];
            $result = $clouddbRespository->ClouddbBusinessSynchronizing($yw_id);
            if($result){
                $ok++;
            }else{
                $err++;
            }
        }
        $this->success("共同步<font color='red'>".$all."</font>个业务，成功<font color='red'>".$ok."</font>个，失败<font color='red'>".$err."</font>个！","",true);
    }

    /**
     * 云数据库租赁服务协议
     * @date: 2018年12月13日15:10:39
     * @author: Guopeng
     */
    public function agreement(){
        if(isMobile() != "phone"){
            $this->_empty();
        }
        $this->display();
    }
}