<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Frontend\Model\MemberModel;
use Common\Aide\ImagesAide;

/**
 * 前台首页
 * @author: Lyubo
 * @时间: 2016年10月21日 下午15:56:08
 */
class LoginController extends FrontendController{

	protected $captcha_type_regist = 'frontend_register';
	protected $captcha_type_login = 'frontend_sign_in';
	protected $model = null;

	public function _initialize(){
		parent::_initialize();
		$this->model = new MemberModel();
	}

	/**
	 * 前台登录页面
	 * @时间: 2016年10月24日 18:19:52
	 * @author: Lyubo
	 */
	public function login(){
		if(session('?user_id')){
			redirect(U('/'),0,'');die();
		}
		if(IS_POST){
			$user = new MemberModel();
			$res = $user->login();
			if($res["status"] === false){
				$msg = $res["msg"];
				$url = $res["url"];
				if(IS_AJAX){
					$this->error($msg,$url,true);
				}else{
					$this->error($msg,$url);
				}
			}else{
				$msg = $res["msg"];
				$url = $res["url"];
				if(IS_AJAX){
					$this->success($msg,$url,true);
				}else{
					$this->success($msg,$url);
				}
			}
		}else{
			$this->display();
		}
	}

	/**
	 * 前台退出
	 * @时间: 2016年10月24日 18:20:20
	 * @author: Lyubo
	 */
	public function logout(){
		session(null);
		redirect(U('/'),0,'');
	}

	/**
	 * 注册页面
	 * @时间: 2016年12月6日 下午5:30:22
	 * @author: duanbin
	 */
	public function register(){
		if(session('?user_id')){
			redirect(U('/'),0,'');die();
		}
		$data = request();
		$uid = $data["uid"]+0;
		if($uid){
			$user = new MemberModel();
			$user_info = $user->where(array("user_id"=>$uid))->find();
			if($user_info){
				$uname = $user_info["user_name"];
			}else{
				$uname = "";
			}
		}else{
			$uname = "";
		}
		$this->assign("uid",$uid);
		$this->assign("uname",$uname);
		$this->display();
	}

	/**
	 * 处理注册逻辑
	 * @时间: 2016年12月7日 上午10:31:25
	 * @author: duanbin
	 */
	public function clerk(){
		$request = request(true);
		$user = new MemberModel();
		//验证码的标识
		$request['type'] = $this->captcha_type_regist;
		$res = $user->regist($request);
		if($res === false){
			$msg = $user->getError();
			if(IS_AJAX){
				$this->error($msg,'',true);
			}else{
				$this->error($msg);
			}
		}else{
			session('user_id',$res['user_id']);
			session('user_name',$res['user_name']);
			session('login_name',$res['login_name']);
			$msg = '欢迎您注册为会员！:)';
			$url = U('member/index');
			if(IS_AJAX){
				$this->success($msg,$url,true);
			}else{
				$this->success($msg,$url);
			}
		}
	}

	/**
	 * QQ/微信登录注册页面&快速注册
	 * @时间: 2019年2月14日15:39:48
	 * @author: GuoPeng
	 */
	public function third_register(){
		if(session('?user_id')){
			if(IS_POST && IS_AJAX){
				$this->error("您已登录！",U("Member/index"),true);
			}else{
				redirect(U('/'),0,'');
			}
		}
		if(!session('?openid_type')){
			if(IS_POST && IS_AJAX){
				$this->error("快速注册失败：注册类型错误，请重新选择注册方式！",U("Login/register"),true);
			}else{
				redirect(U('login'),0,'');
			}
		}
		$openid_type = session('openid_type');
		if($openid_type !== "QQ" && $openid_type !== "WX"){
			if(IS_POST && IS_AJAX){
				$this->error("快速注册失败：注册类型错误，请重新选择注册方式！",U("Login/register"),true);
			}else{
				redirect(U('login'),0,'');
			}
		}
		if(!session('?openid')){
			if(IS_POST && IS_AJAX){
				$this->error("快速注册失败：缺少关键数据，请重新选择注册方式！",U("Login/register"),true);
			}else{
				redirect(U('login'),0,'');
			}
		}
		if(IS_POST && IS_AJAX){
			$data = request();
			$type = $data["type"];
			if($type !== "register"){
				$this->error("请按正常流程注册！",U("login/register"),true);
			}else{
				$user = new MemberModel();
				$res = $user->quick_register();
				if($res["status"] === false){
					$msg = $res["msg"];
					$url = $res["url"];
					$this->error($msg,$url,true);
				}else{
					$msg = $res["msg"];
					$url = $res["url"];
					$this->success($msg,$url,true);
				}
			}
		}
		$this->assign("openid_type",$openid_type);
		$this->display();
	}

	/**
	 * 登录和注册获取验证码的方法
	 * @时间: 2016年12月1日 上午10:04:36
	 * @author: duanbin
	 */
	public function captcha(){
		$request = request(true);
		$imagesAide = new ImagesAide();
		$imagesAide->capthca($request['type']);
	}

	/**
	 * 检测用户是否注册
	 * @date: 2017年4月21日 下午6:18:56
	 * @author: Lyubo
	 * @param: variable
	 */
	public function checkLogin(){
		$request = request(true);
		$user = new MemberModel();
		$res = $user->checkLogin($request);
		if(IS_AJAX){
			if($res !== false){
				$msg = "登录名可用！";
				$this->success($msg,'',true);
			}else{
				$msg = $user->getError();
				$this->error($msg,'',true);
			}
		}else{
			$msg = '请求方式错误';
			$this->error($msg,'');
		}
	}

	/**
	 * 检测用户是否存在
	 * @date: 2017年7月7日 上午10:39:56
	 * @author: Guopeng
	 */
	public function check_user(){
		$request = request(true);
		$user = new MemberModel();
		$res = $user->check_user($request);
		if(IS_AJAX){
			if($res !== false){
				$this->success('用户验证成功','',$res);
			}else{
				$msg = $user->getError();
				$this->error($msg,'',true);
			}
		}else{
			$msg = '请求方式错误!';
			$this->error($msg,'');
		}
	}

	/**
	 * 注册发送验证码
	 * @date 2017年10月17日 15:37:05
	 * @author: Guopeng
	 */
	public function register_sendMail(){
		$member = new MemberModel();
		$result = $member->register_sendMail();
		if($result === true){
			$msg = "验证码发送成功，请在30分钟内使用！";
			$this->success($msg,"",true);
		}elseif($result === -1){
			$msg = "邮件发送失败，请联系管理员！";
			$this->error($msg,$member->getError(),true);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}

	/**
	 * 验证邮箱验证码
	 * @date: 2017年7月7日 下午17:26:55
	 * @author: Guopeng
	 */
	public function check_mail_code(){
		$member = new MemberModel();
		$result = $member->check_mail_code();
		if($result !== false){
			$msg = "邮箱验证码验证成功！";
			$this->success($msg,"",$result);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}

	/**
	 * 推荐人验证
	 * @时间: 2019年2月13日11:20:55
	 * @author: GuoPeng
	 */
	public function check_recommend(){
		$data = request();
		$recommend = $data["recommend"];
		$user = new MemberModel();
		if($recommend){
			$user_info = $user->where(array("user_name"=>$recommend))->find();
			if($user_info){
				$this->success($user_info["user_id"],"",true);
			}else{
				$this->error("推荐人用户不存在，请确认后重新填写！",'',true);
			}
		}else{
			$this->success("","",true);
		}
	}

	/**
	 * 通过邮箱找回密码
	 * @date: 2017年2月20日 下午3:21:12
	 * @author: Lyubo
	 * @param: variable
	 */
	public function find_pass(){
		$this->display();
	}

	/**
	 * 找回密码发送验证邮件
	 * @author: Guopeng
	 * return: ajax\json
	 */
	public function send_mail(){
		if(IS_POST){
			$member = new MemberModel();
			$result = $member->sendMail();
			if($result !== false){
				$msg = "验证码发送成功，请在30分钟内使用！";
				$this->success($msg,"",true);
			}else{
				$msg = $member->getError();
				$this->error($msg,"",true);
			}
		}else{
			$this->_empty();
		}
	}

	/**
	 * 重置密码
	 * @date: 2017年7月10日 上午10:26:55
	 * @author: Guopeng
	 */
	public function update_pass(){
		$member = new MemberModel();
		$result = $member->check_mail_code();
		if($result !== false){
			$msg = "密码重置成功！";
			$this->success($msg,U("login/login"),true);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}

	/**
	 * QQ第三方登录
	 * @date: 2017年9月20日 下午17:16:55
	 * @author: Guopeng
	 */
	public function QQ_login(){
		if(session('?user_id')){
			redirect(U('/'),0,'');die();
		}
		$member = new MemberModel();
		$result = $member->QQ_login();
		if($result["status"] === false){
			$msg = $result["msg"];
			if($msg === false){
				redirect('/login/third_register');
			}else{
				$url = $result["url"];
				R("Empty/error_page",array($msg,$url));
			}
		}else{
			header("Content-type:text/html;charset=utf-8");
			$url = U("Member/index");
			echo "<script language=\"JavaScript\">alert(\"登录成功！\");window.location.href = \"{$url}\";</script>";die;
		}
	}

	/**
	 * 微信三方登录
	 * @date: 2018年9月13日16:00:15
	 * @author: Guopeng
	 */
	public function wx_login(){
		if(session('?user_id')){
			redirect(U('/'),0,'');die();
		}
		session('openid_type',null);
		session('openid',null);
		$system = WebSiteConfig(6);
		$request = request();
		//应用的APPID
		$app_id = $system["login_wx_appid"];
		//应用的APPKEY
		$app_secret = $system["login_wx_appsecret"];
		//成功授权后的回调地址
		$my_url = urlencode($system["login_wx_redirect_url"]);
		//Step1：获取Authorization Code
		$code = $request["code"];
		if(empty($code)){
			//state参数用于防止CSRF攻击，成功授权后回调时会原样带回
			$state = md5(uniqid(rand(),TRUE));
			session('wx_state',$state);
			//拼接URL
			$dialog_url = "https://open.weixin.qq.com/connect/qrconnect?appid={$app_id}&redirect_uri={$my_url}&response_type=code&scope=snsapi_login&state={$state}#wechat_redirect";
			header("Location:$dialog_url");
		}
		//Step2：通过Authorization Code获取Access Token和OpenID
		if($request['state'] == session('wx_state')){
			//拼接URL
			$token_url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid={$app_id}&secret={$app_secret}&code={$code}&grant_type=authorization_code";
			$response = get_url_content($token_url);
			if(strpos($response,"callback") !== false){
				$lpos = strpos($response,"(");
				$rpos = strrpos($response,")");
				$response = substr($response,$lpos + 1,$rpos - $lpos - 1);
			}
			//$response = '{"openid":"A9C685D7F1AE8A9A3421F0"'.time().'}';
			$user = json_decode($response);
			if(isset($user->errcode)){
				R("Empty/error_page",array($user->errcode.":".$user->errmsg,U("login/login")));
			}
			$openid = $user->openid;
			if(empty($openid)){
				R("Empty/error_page",array("登录失败！",U("login/login")));
			}
			$member = new MemberModel();
			$result = $member->wx_login($user);
			session('wx_state',null);
			if($result !== false){
				header("Content-type:text/html;charset=utf-8");
				$url = U("Member/index");
				echo "<script language=\"JavaScript\">alert(\"登录成功！\");window.location.href = \"{$url}\";</script>";die;
			}else{
				$msg = $member->getError();
				if($msg === false){
					session('openid_type',"WX");
					session('openid',$openid);
					redirect('third_register');
				}else{
					R("Empty/error_page",array($msg,U("login/login")));
				}
			}
		}else{
			R("Empty/error_page",array("The state does not match. You may be a victim of CSRF.",U("login/login")));
		}
	}
}