<?php
namespace Frontend\Controller;
use Frontend\Controller\FrontendController;
use Frontend\Model\MemberModel;
use Frontend\Model\FinancialModel;

/**
* 会员中心
* @date: 2016年10月25日 上午10:23:41
* @author: Lyubo
*/
class MemberController extends FrontendController{

    /**
     * 判断用户是否登陆
     * @date: 2016年10月25日 下午3:25:56
     * @author : Lyubo
     */
    public function _initialize(){
        parent::_initialize();
        if (!session('?user_id')){
			if(IS_AJAX){
				$this->error("请先登录！",U("Login/login"),true);
			}else{
				redirect(U('Login/login'),0,'');die();
			}
        }
    }

    public function index(){
        $member = new MemberModel();
        $member_info = $member->get_member_money();
        $article = new \Frontend\Model\ArticleModel();
        $notices = $article->home_news(array("type"=>3));
        $this->assign([
            "notices"=>$notices,
            "member_info"=>$member_info
        ]);
        $this->display();
    }

    /**
    * 获取会员信息
    * @date: 2016年11月1日 下午3:22:12
    * @author: Lyubo
    * @param: $info
    */
    public function memberinfo(){
        $member = new MemberModel();
        $where = $member->conver_par();
        $member_info = $member->get_member_info($where);
        if(IS_POST){
            $result = $member->member_modify_info($where);
            if($result !== false){
                session('user_name',I('post.user_name'));
                $this->success("修改信息成功",U("member/memberinfo"));
            }else{
                $msg = $member->getError();
                $msg = "修改信息失败-".$msg;
                $this->error($msg,U("member/memberinfo"));
            }
        }else {
            $email = $member_info["user_mail"];
            if(!empty($email)){
                $arr = explode('@',$email);
                $arr[0] = substr_replace($arr[0],'****',4);
                $email = $arr[0]."@".$arr[1];
            }else{
				$email = "未绑定邮箱";
			}
            $this->assign(["member_info"=>$member_info,"email"=>$email]);
            $this->display();
        }
    }

    /**
    * 安全中心
    * @date: 2016年11月1日 下午3:45:59
    * @author: Lyubo
    */
    public function membersafe(){
        $member = new MemberModel();
        $where = $member->conver_par();
        $member_info = $member->get_member_info($where);
		$email = $member_info["user_mail"];
		if(!empty($email)){
			$arr = explode('@',$email);
			$arr[0] = substr_replace($arr[0],'****',4);
			$email = $arr[0]."@".$arr[1];
		}
        $this->assign(["email" => $email,"user_name"=>$member_info["user_name"]]);
        $this->display();
    }

    /**
     * 修改登录名
     * @时间: 2019年2月13日11:20:55
     * @author: GuoPeng
     */
    public function modify_login_name(){
        $member = new MemberModel();
        $res = $member->modify_login_name();
        if($res["status"]){
			$this->success("登录名修改成功！","",$res["msg"]);
        }else{
            $this->error("失败","",$res["msg"]);
        }
    }
    
    /**
    * 修改会员密码（原密码修改）
    * @date: 2016年11月1日 下午4:38:55
    * @author: Lyubo
    * @return boolean
    */
    public function memeber_modify_pass(){
        $member = new MemberModel();
        $data = $member->conver_par();
        $result = $member->member_modify_pass($data);
        if($result !== false){
            $msg = "密码修改成功！";
            $this->success($msg,"",true);
        }else{
            $msg = $member->getError();
            $this->error($msg,"",true);
        }
    }

    /**
     * 业务数获取
     * @date: 2016年12月8日 上午10:09:49
     * @author: Guopeng
     */
    public function state_count(){
        $user_id = intval(session("user_id"));
        $member = new MemberModel();
        $sum = $member->ywcount($user_id);
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 发送验证邮件
     * @author: Guopeng
     * return: ajax\json
     */
    public function memeber_sendMail(){
        if(IS_POST){
            $member = new MemberModel();
            $result = $member->sendMail();
            if($result !== false){
                $msg = "验证码发送成功，请在30分钟内使用！";
                $this->success($msg,"",true);
            }else{
                $msg = $member->getError();
                $this->error($msg,"",true);
            }
        }else{
            $this->_empty();
        }
    }

    /**
     * 修改绑定邮箱
     * @date: 2017年7月5日 上午11:26:55
     * @author: Guopeng
     */
    public function member_mail(){
        $member = new MemberModel();
        if(IS_POST){
            $result = $member->member_modify_mail();
            if($result !== false){
                $msg = "邮箱修改成功！";
                $this->success($msg,"",true);
            }else{
                $msg = $member->getError();
                $this->error($msg,"",true);
            }
        }else{
			$where = $member->conver_par();
			$member_info = $member->get_member_info($where);
			$email = $member_info["user_mail"];
			if(!empty($email)){
				$arr = explode('@',$email);
				$arr[0] = substr_replace($arr[0],'****',4);
				$email = $arr[0]."@".$arr[1];
			}
			$this->assign(["email" => $email]);
            $this->display();
        }
    }

    /**
     * 绑定QQ
     * @date: 2018年9月12日16:05:26
     * @author: Guopeng
     */
    public function bind_qq(){
		$mid = session('user_id');
		if(empty($mid)){
			$this->error("请先登录！",U("member/memberinfo"));
		}
		$member = new MemberModel();
		$where["user_id"] = $mid;
		$member_info = $member->get_member_info($where);
		if(!$member_info){
			$this->error("该会员不存在！",U("member/memberinfo"));
		}
		if($member_info["qq_openid"]){
			$this->error("已绑定QQ账号！",U("member/memberinfo"));
		}
        $system = WebSiteConfig(6);
        $request = request();
        //应用的APPID
        $app_id = $system["login_qq_appid"];
        //应用的APPKEY
        $app_secret = $system["login_qq_appkey"];
        //成功授权后的回调地址
        $my_url = $system["login_qq_callback2"];
        //Step1：获取Authorization Code
        $code = $request["code"];
        if(empty($code)){
            //state参数用于防止CSRF攻击，成功授权后回调时会原样带回
            $state = md5(uniqid(rand(),TRUE));
            session('state',$state);
            //拼接URL
            $dialog_url = "https://graph.qq.com/oauth2.0/authorize?response_type=code&client_id=".$app_id."&redirect_uri=".urlencode($my_url)."&state=".$state;
            header("Location:$dialog_url");
        }
        //Step2：通过Authorization Code获取Access Token
        if($request['state'] == session('state')){
            //拼接URL
            $token_url = "https://graph.qq.com/oauth2.0/token?grant_type=authorization_code&"."client_id=".$app_id."&redirect_uri=".urlencode($my_url)."&client_secret=".$app_secret."&code=".$code;
            $response = get_url_content($token_url);
            if(strpos($response,"callback") !== false){
                $lpos = strpos($response,"(");
                $rpos = strrpos($response,")");
                $response = substr($response,$lpos + 1,$rpos - $lpos - 1);
                $msg = json_decode($response);
                if(isset($msg->error)){
                    $this->error($msg->error.$msg->error_description);
                }
            }
            //Step3：使用Access Token来获取用户的OpenID
            $params = array();
            parse_str($response,$params);
            $graph_url = "https://graph.qq.com/oauth2.0/me?access_token=".$params['access_token'];
            $str = get_url_content($graph_url);
            if(strpos($str,"callback") !== false){
                $lpos = strpos($str,"(");
                $rpos = strrpos($str,")");
                $str = substr($str,$lpos + 1,$rpos - $lpos - 1);
            }
            $user = json_decode($str);
            if(isset($user->error)){
                $this->error($user->error.$user->error_description);
            }
            $member = new MemberModel();
            $result = $member->bind_qq($user,$member_info);
            if($result !== false){
                $url = U("member/memberinfo");
                $msg = "绑定成功！";
                $this->success($msg,$url);
            }else{
                $msg = $member->getError();
                $this->error($msg,U("member/memberinfo"));
            }
        }else{
            $this->error("The state does not match. You may be a victim of CSRF.",U("member/memberinfo"));
        }
    }

    /**
     * 绑定微信
     * @date: 2018年9月13日15:42:56
     * @author: Guopeng
     */
    public function bind_wx(){
        $mid = session('user_id');
        if(empty($mid)){
            $this->error("请先登录！",U("member/memberinfo"));
        }
        $member = new MemberModel();
        $where["user_id"] = $mid;
        $member_info = $member->get_member_info($where);
        if(!$member_info){
            $this->error("该会员不存在！",U("member/memberinfo"));
        }
        if($member_info["wx_openid"]){
            $this->error("已绑定微信账号！",U("member/memberinfo"));
        }
        $system = WebSiteConfig(6);
        $request = request();
        //应用的APPID
        $app_id = $system["login_wx_appid"];
        //应用的APPKEY
        $app_secret = $system["login_wx_appsecret"];
        //成功授权后的回调地址
        $my_url = urlencode($system["login_wx_redirect_url2"]);
        //Step1：获取Authorization Code
        $code = $request["code"];
        if(empty($code)){
            //state参数用于防止CSRF攻击，成功授权后回调时会原样带回
            $state = md5(uniqid(rand(),TRUE));
            session('state',$state);
            //拼接URL
            $dialog_url = "https://open.weixin.qq.com/connect/qrconnect?appid={$app_id}&redirect_uri={$my_url}&response_type=code&scope=snsapi_login&state={$state}#wechat_redirect";
            header("Location:$dialog_url");
        }
        //Step2：通过Authorization Code获取Access Token
        if($request['state'] == session('state')){
            //拼接URL
            $token_url = "https://api.weixin.qq.com/sns/oauth2/access_token?appid={$app_id}&secret={$app_secret}&code={$code}&grant_type=authorization_code";
            $response = get_url_content($token_url);
            $user = json_decode($response);
            if(isset($user->error)){
                $this->error($user->error.$user->error_description,U("member/memberinfo"));
            }
            $member = new MemberModel();
            $result = $member->bind_wx($user,$member_info);
            if($result !== false){
                $url = U("member/memberinfo");
                $msg = "绑定成功！";
                $this->success($msg,$url);
            }else{
                $msg = $member->getError();
                $this->error($msg,U("member/memberinfo"));
            }
        }else{
            $this->error("The state does not match. You may be a victim of CSRF.",U("member/memberinfo"));
        }
    }

    /**
     * 解绑QQ/微信
     * @date: 2018年10月10日14:19:04
     * @author: Guopeng
     */
    public function unbind(){
		$request = request();
		$type = $request["type"];
        if(IS_AJAX){
            $member = new MemberModel();
            $user_id = session("user_id");
			if($type === "qq"){
                $res = $member->where(array("id"=>$user_id))->save(array("qq_openid"=>0));
			}elseif($type === "wx"){
				$res = $member->where(array("id"=>$user_id))->save(array("wx_openid"=>0));
            }else{
                $this->error("解绑失败！","",true);
            }
			if($res !== false){
				$this->success("解绑成功！","",true);
			}else{
				$this->error("解绑失败！","",true);
			}
		}
    }

    /**
     * 手机版 --“我的”页面
    */
    public function myinfo(){
        $member = new MemberModel();
        $member_info = $member->get_member_money();
        $article = new \Frontend\Model\ArticleModel();
        $notices = $article->home_news(array("type"=>3));
        $this->assign([
            "notices"=>$notices,
            "member_info"=>$member_info
        ]);

        $financial = new FinancialModel();
        $where = $financial->conver_par();
        $member_account_info = $financial->account_info($where);
        $this->assign(['account_info' => $member_account_info]);


        $this->display();

    }

}