<?php
namespace Frontend\Model;

use Common\Aide\ImagesAide;
use Think\Model;

class MemberModel extends Model{
	protected $captcha_type_regist = 'frontend_register';
	protected $captcha_type_register = 'frontend_third_register';
	protected $captcha_type_login = 'frontend_sign_in';
	protected $trueTableName = 'agent_member';
	protected $_validate = array();

	public function conver_par(){
		$where["user_id"] = array("eq",session("user_id"));
		return $where;
	}

	/********************登录控制器(LoginController)********************/
	/**
	 * 登录
	 * @date: 2019年2月15日10:31:55
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function login(){
		$date = request(true);
		$request['captcha'] = $date['captcha'];
		$request['type'] = $this->captcha_type_login;
		$openid_type = "";
		if(session('?openid_type')){
			$openid_type = session('openid_type');
		}
		if($openid_type !== "QQ" && $openid_type !== "WX"){
			$openid_type = "";
		}
		if(!session('?openid')){
			$openid_type = "";
		}
		$msg = "登录";
		if($openid_type !== ""){
			$request['type'] = $this->captcha_type_register;
			$msg = "绑定";
		}
		$imagesAide = new ImagesAide();
		$captcha_res = $imagesAide->checkCaptcha($request['captcha'],$request['type']);
		if(!$captcha_res){
			$return["status"] = false;
			$return["msg"] = "{$msg}失败：验证码不对哦！";
			$return["url"] = U("Login/login");
			return $return;
		}
		$url = session("?backward") ? session("backward") : U("Member/index");
		if(!$date['user_name']){
			$return["status"] = false;
			$return["msg"] = "{$msg}失败：用户名不能为空！";
			$return["url"] = U("Login/login");
			return $return;
		}
		$where1['login_name'] = array("eq",$date['user_name']);
		$result = $this->get_member_info($where1);
		if(!$result){
			$where2['user_mail'] = array("eq",$date['user_name']);
			$result = $this->get_member_info($where2);
		}
		if($result){
			//验证数据库中去出的密码是否一致
			if($result['user_pass'] == pwd($result['login_name'],md5($date['user_pass']))){
				/*验证用户状态*/
				if($result['user_state'] == 1){
					if($openid_type == "QQ"){
						if($result["qq_openid"] != ""){
							$return["status"] = false;
							$return["msg"] = "{$msg}失败：该会员已绑定QQ账号！";
							$return["url"] = $url;
							return $return;
						}
						$where["user_id"] = $result["user_id"];
						$res = $this->where($where)->save(array("qq_openid"=>session('openid')));
						if($res === false){
							$return["status"] = false;
							$return["msg"] = "{$msg}失败：会员绑定QQ账号失败！";
							$return["url"] = $url;
							return $return;
						}
					}elseif($openid_type == "WX"){
						if($result["wx_openid"] != ""){
							$return["status"] = false;
							$return["msg"] = "{$msg}失败：该会员已绑定QQ账号！";
							$return["url"] = $url;
							return $return;
						}
						$where["user_id"] = $result["user_id"];
						$res = $this->where($where)->save(array("wx_openid"=>session('openid')));
						if($res === false){
							$return["status"] = false;
							$return["msg"] = "{$msg}失败：会员绑定微信账号失败！";
							$return["url"] = $url;
							return $return;
						}
					}
					session('openid_type',null);
					session('openid',null);
					session('backward',null);
					session('user_id',$result['user_id']);
					session('user_name',$result['user_name']);
					session('login_name',$result['login_name']);
					$return["status"] = true;
					$return["msg"] = "{$msg}成功！";
					$return["url"] = $url;
					return $return;
				}else{
					$return["status"] = false;
					$return["msg"] = "{$msg}失败：该用户状态异常！";
					$return["url"] = U("Login/login");
					return $return;
				}
			}else{
				$return["status"] = false;
				$return["msg"] = "{$msg}失败：密码错误！";
				$return["url"] = U("Login/login");
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "{$msg}失败：该用户未注册,请注册后登录！";
			$return["url"] = U("Login/login");
			return $return;
		}
	}

	/**
	 * 注册的业务逻辑
	 * @时间: 2016年12月7日 上午10:57:56
	 * @author: duanbin
	 * @param: variable
	 * @return bool
	 */
	public function regist($request){
		//验证数据
//    	if ($request['agree'] == false){
//    		$this->error = '您尚未同意注册协议';
//    		return  false;
//    	}
		$imagesAide = new ImagesAide();
		$captcha_res = $imagesAide->checkCaptcha($request['captcha'],$request['type']);
		if(!$captcha_res){
			$this->error = '验证码不对哦';
			return false;
		}
		if(!filter_var($request['user_mail'],FILTER_VALIDATE_EMAIL)){
			$this->error = '邮箱格式不正确哦！';
			return false;
		}
		if(!empty($request['user_qq'])){
			if(!is_numeric($request['user_qq'])){
				$this->error = '请填写正确的qq号码';
				return false;
			}
		}
		if(!empty($request['user_mobile'])){
			if(!is_tel($request['user_mobile'])){
				$this->error = '手机号码格式不对';
				return false;
			}
		}
		//查看是否有人注册过了。。。
		$exists = $this->where(['login_name' => ['eq',$request['username']]])->find();
		if(!empty($exists)){
			$this->error = '该用户已经存在啦，换一个试试吧！';
			return false;
		}
		$exists = $this->where(['user_mail' => ['eq',$request['user_mail']]])->find();
		if(!empty($exists)){
			$this->error = '该邮箱已被注册，换一个试试吧！';
			return false;
		}
		if(isMobile() != 'phone' || C('DEFAULT_THEME') != "Default"){
			$custom_config = WebSiteConfig(9);
			if($custom_config["register_mail_check"] == "yes"){
				$register = M("member_register_mail");
				$exists = $register->where(['mail_code' => ['eq',$request['ecode']]])->find();
				if(empty($exists)){
					$this->error = '邮箱验证码错误！';
					return false;
				}else{
					if($exists["user_mail"] != $request['user_mail']){
						$this->error = '邮箱与获取验证码邮箱不一致！';
						return false;
					}
					$code_time = strtotime($exists['time']) + 30 * 60;
					if($code_time <= time()){
						$this->error = '邮箱验证码已过期，请重新发送验证码！';
						return false;
					}
				}
			}
		}
		if(!passwordIsStrong($request['password'])){
			$this->error = '密码必须是6到20位数字、字母或特殊字符组成！';
			return false;
		}
		if($request['password'] != $request['confirm_password']){
			$this->error = '密码和确认密码不一致';
			return false;
		}
		$recommend = $request["user_recommend"];
		$recommend_id = $request["user_recommend_id"]+0;
		if($recommend != "" && $recommend_id){
			$user_info = $this->where(array("user_id"=>$recommend_id,"user_name"=>$recommend))->find();
			if($user_info){
				$data['recommend_name'] = $recommend;
				$data['recommend_id'] = $recommend_id;
			}else{
				$this->error = '推荐人用户不存在，请确认后重新填写！';
				return false;
			}
		}
		$openid_type = "";
		if(session('?openid_type')){
			$openid_type = session('openid_type');
		}
		if($openid_type !== "QQ" && $openid_type !== "WX"){
			$openid_type = "";
		}
		if(!session('?openid')){
			$openid_type = "";
		}
		$openid = session('openid');
		if(empty($openid)){
			$openid_type = "";
		}
		$msg = "注册";
		if($openid_type !== ""){
			$url = U("Member/index");
			if($openid_type == "QQ"){
				$res = $this->where(array("qq_openid"=>$openid))->find();
				if(!empty($res)){
					$return["status"] = false;
					$return["msg"] = "{$msg}失败：该QQ账号已绑定会员！";
					$return["url"] = $url;
					return $return;
				}else{
					$data['qq_openid'] = $openid;
				}
			}else{
				$res = $this->where(array("wx_openid"=>session('openid')))->find();
				if(!empty($res)){
					$return["status"] = false;
					$return["msg"] = "{$msg}失败：该微信账号已绑定会员！";
					$return["url"] = $url;
					return $return;
				}else{
					$data['wx_openid'] = $openid;
				}
			}
		}
		//添加到数据库
		$data['user_state'] = 1;
		$data['type'] = 1;
		$data['login_name'] = $request['username'];
		$data['user_mail'] = $request['user_mail'];
		$data['user_name'] = $request['username'];
		$data['user_pass'] = pwd($request['username'],md5($request['password']));
		$data['create_time'] = date('Y-m-d H:i:s');
		$data['user_code'] = '';
		$data['user_province'] = '';
		$data['user_city'] = '';
		$data['user_address'] = '';
		$data['user_mobile'] = $request['user_mobile'] ? $request['user_mobile'] : '';
		$data['user_postal'] = '';
		$data['user_qq'] = $request['user_qq'];
		$data['password_level'] = $request['password_level'] ? $request['password_level'] : 2;
		$res = $this->add($data);
		if($res === false){
			$this->error = '服务器繁忙，请稍后再试！';
			return false;
		}else{
			session('openid_type',null);
			session('openid',null);
			//这里生成一条member_account记录
			$m_member_account = M('member_account');
			$m_member_account->add([
				'user_id' => $res,
				'state' => 1,
				'balance' => 0,
				'purchases' => 0,
				'update_time' => date('Y-m-d H:i:s')
			]);
			return ['user_id' => $res,'user_name' => $data['user_name'],'login_name' => $data['login_name']];
		}
	}

	/**
	 * 快速注册
	 * @时间: 2019年2月15日15:05:09
	 * @author: GuoPeng
	 * @return mixed
	 */
	public function quick_register(){
		if(!session('?openid_type')){
			$return["status"] = false;
			$return["msg"] = "快速注册失败：注册类型错误，请重新选择注册方式！";
			$return["url"] = U("login/login");
			return $return;
		}
		$openid_type = session('openid_type');
		if($openid_type !== "QQ" && $openid_type !== "WX"){
			$return["status"] = false;
			$return["msg"] = "快速注册失败：注册类型错误，请重新选择注册方式！";
			$return["url"] = U("login/login");
			return $return;
		}
		if(!session('?openid')){
			$return["status"] = false;
			$return["msg"] = "快速注册失败：缺少关键数据，请重新选择注册方式！";
			$return["url"] = U("login/login");
			return $return;
		}
		$openid = session('openid');
		if(empty($openid)){
			$return["status"] = false;
			$return["msg"] = "快速注册失败：缺少关键数据，请重新选择注册方式！";
			$return["url"] = U("login/login");
			return $return;
		}
		if($openid_type == "QQ"){
			$res = $this->where(array("qq_openid"=>$openid))->find();
			if(!empty($res)){
				$return["status"] = false;
				$return["msg"] = "快速注册失败：该QQ账号已绑定会员！";
				$return["url"] = U("Login/third_register");
				return $return;
			}else{
				$data['qq_openid'] = $openid;
				$login_name = "qq".time();
			}
		}else{
			$res = $this->where(array("wx_openid"=>session('openid')))->find();
			if(!empty($res)){
				$return["status"] = false;
				$return["msg"] = "快速注册失败：该微信账号已绑定会员！";
				$return["url"] = U("Login/third_register");
				return $return;
			}else{
				$data['wx_openid'] = $openid;
				$login_name = "wx".time();
			}
		}
		$data['user_state'] = 1;
		$data['type'] = 1;
		$data['login_name'] = $login_name;
		$data['user_mail'] = "";
		$data['user_name'] = $login_name;
		$data['user_pass'] = pwd($login_name,md5(12345678));
		$data['create_time'] = date('Y-m-d H:i:s');
		$data['user_code'] = '';
		$data['user_province'] = "";
		$data['user_city'] = "";
		$data['user_address'] = '';
		$data['user_mobile'] = '';
		$data['user_postal'] = '';
		$data['user_qq'] = "";
		$data['recommend_name'] = "";
		$data['recommend_id'] = 0;
		$res = $this->add($data);
		$user_id = $this->getLastInsID();
		if($res !== false){
			$m_member_account = M('member_account');
			$m_member_account->add([
				'user_id' => $res,
				'state' => 1,
				'balance' => 0,
				'purchases' => 0,
				'update_time' => date('Y-m-d H:i:s')
			]);
			session('openid_type',null);
			session('openid',null);
			session('user_id',$user_id);
			session('user_name',$login_name);
			session('login_name',$login_name);
			$return["status"] = true;
			$return["msg"] = "快速注册成功，初始密码：12345678，请尽快修改密码！";
			$return["url"] = U("Member/index");
			return $return;
		}else{
			$return["status"] = false;
			$return["msg"] = "快速注册失败：网络繁忙，请稍后再试！";
			$return["url"] = U("Login/third_register");
			return $return;
		}
	}

	/**
	 * 检查登录名是否已被注册
	 * @param $request
	 * @return bool
	 */
	public function checkLogin($request){
		if($request['check_type'] == '1'){
			//查看是否有人注册过了。。。
			$exists = $this->where(['login_name' => ['eq',$request['username']]])->find();
			if(!empty($exists)){
				$this->error = '该用户已经存在啦，换一个试试吧 :)';
				return false;
			}
			return true;
		}elseif($request['check_type'] == '2'){
			$imagesAide = new ImagesAide();
			$captcha_res = $imagesAide->checkCaptcha($request['captcha'],$request['type']);
			if(!$captcha_res){
				$this->error = '验证码不对哦';
				return false;
			}
			return true;
		}
	}

	/**
	 * 验证用户/邮箱是否存在
	 * @date: 2017年7月7日 下午13:59:55
	 * @param $request
	 * @return bool
	 */
	public function check_user($request){
		$type = "frontend_check_user";
		$imagesAide = new ImagesAide();
		$captcha_res = $imagesAide->checkCaptcha($request['captcha'],$type);
		if(!$captcha_res){
			$this->error = '验证码不对哦';
			return false;
		}
		//查看该用户是否存在
		$exists = $this->where(['login_name' => ['eq',$request['user_name']]])->find();
		if(empty($exists)){
			$exists = $this->where(['user_mail' => ['eq',$request['user_name']]])->find();
		}
		if(empty($exists)){
			$this->error = '查询的用户不存在，请核对您填写的登录名/邮箱！';
			return false;
		}
		if($exists['user_state'] != 1){
			$this->error = "该用户已被禁用,请联系管理员";
			return false;
		}
		if(empty($exists["user_mail"])){
			$this->error = '该会员未绑定邮箱，请联系管理员！';
			return false;
		}
		$arr = explode('@',$exists["user_mail"]);
		$arr[0] = substr_replace($arr[0],'****',4);
		$email = $arr[0]."@".$arr[1];
		$info["email"] = $email;
		$info["user_mail"] = $exists["user_mail"];
		$info["user_id"] = $exists["user_id"];
		return $info;
	}

	/**
	 * 注册发送验证码
	 * @date 2017年10月17日 15:37:05
	 * @author: Guopeng
	 * @return bool
	 */
	public function register_sendMail(){
		$login_name = request()["user_name"];
		$user_mail = request()["user_mail"];
		$where["login_name"] = $login_name;
		$where["user_mail"] = $user_mail;
		if($this->where(["login_name" => $login_name])->find()){
			$this->error = '该用户已经存在啦，换一个试试吧 :)！';
			return false;
		}
		if($this->where(["user_mail" => $user_mail])->find()){
			$this->error = '该邮箱已绑定其他会员啦，换一个试试吧 :)！';
			return false;
		}
		$randStr = str_shuffle('012345678901234567890123456789');
		$rand = substr($randStr,0,6);
		$time = time();
		$date = date("Y-m-d H:i:s",$time);
		$business_info["code"] = $rand;
		$business_info["time"] = $time;
		$data["mail_code"] = $rand;
		$data["time"] = $date;
		$register = M("member_register_mail");
		$info = $register->where($where)->find();
		if($info){
			$res = $register->where($where)->save($data);
		}else{
			$data["login_name"] = $login_name;
			$data["user_mail"] = $user_mail;
			$res = $register->where($where)->add($data);
		}
		if($res !== false){
			//组装邮件内容
			$mail_content = HTMLContentForEmail(12,$business_info,["user_name" => ""]);
			//发送邮件
			$res = postOffice($user_mail,$mail_content['subject'],$mail_content['body'],12);
			if($res["status"] == 1){
				$this->error = '邮件发送失败，请联系管理员！'.$res["message"];
				return -1;
			}else{
				return true;
			}
		}else{
			$this->error = '发送邮件失败，请联系管理员！';
			return false;
		}
	}

	/**
	 * 验证邮箱验证码
	 * @date: 2017年7月7日 下午17:26:55
	 * @author: Guopeng
	 * @return bool
	 */
	public function check_mail_code(){
		$data = request();
		$type = $data["type"] + 0;
		$user_id = $data["user_id"] + 0;
		if(!$user_id){
			$this->error = '未查询到该会员，请重试！';
			return false;
		}
		$user_mail = $data["user_mail"];
		$ecode = clearXSS(I("post.ecode"));
		if(strlen($ecode) !== 6){
			$this->error = '验证码错误！';
			return false;
		}
		$where["user_id"] = array("eq",$user_id);
		$where["user_mail"] = array("eq",$user_mail);
		$info = $this->where($where)->find();//先查询是否存在会员
		if(!$info){
			$this->error = '未查询到该会员，请重试！';
			return false;
		}
		$code_time = strtotime($info['code_time']) + 30 * 60;
		if($code_time <= time()){
			$this->error = '验证码已过期，请重新发送验证码！';
			return false;
		}
		if($ecode != $info['code']){
			$this->error = '验证码错误！';
			return false;
		}
		if($type == 1){
			$user_pass = $data["user_pass"];
			$user_pass2 = $data["user_pass2"];
			if(!passwordIsStrong($user_pass)){
				$this->error = '密码必须是6到20位数字、字母或特殊字符组成！';
				return false;
			}
			if($user_pass != $user_pass2){
				$this->error = '确认密码和新密码不一致！';
				return false;
			}
			$upd_info["code"] = 0;
			$upd_info["user_pass"] = pwd($info["login_name"],md5($user_pass));
			//会员存在进行修改密码
			$res = $this->where($where)->save($upd_info);
			if($res === false){
				$this->error = '服务器繁忙，请重试！';
				return false;
			}else{
				return true;
			}
		}else{
			$return["user_id"] = $user_id;
			$return["email"] = $user_mail;
			$return["code"] = $ecode;
			return $return;
		}
	}

	/**
	 * 找回密码发送邮箱验证码邮件
	 * 时间: 2017年7月24日 下午2:16:42
	 * author: Guopeng
	 * param: variable
	 * return: type
	 */
	public function sendMail(){
		$data = request();
		$mail = $data["mail"];
		$user_id = $data["user_id"] + 0 ? $data["user_id"] + 0 : session("user_id");
		$where["user_id"] = array("eq",$user_id);
		//获取会员信息
		$member_info = $this->get_member_info($where);
		$randStr = str_shuffle('012345678901234567890123456789');
		$rand = substr($randStr,0,6);
		$time = time();
		$date = date("Y-m-d H:i:s",$time);
		$business_info["code"] = $rand;
		$business_info["time"] = $time;
		//如果该会员有邮箱
		if($mail == '0'){
			if(!empty($member_info['user_mail'])){
				$info["code"] = $rand;
				$info["code_time"] = $date;
				$mail = $member_info['user_mail'];
			}else{
				$this->error = '您未绑定邮箱，请先绑定邮箱！';
				return false;
			}
		}else{
			$reg = "/^[A-Za-z0-9]+([-_.][A-Za-z0-9]+)*@([A-Za-z0-9]+\.)+[A-Za-z]{2,5}$/i";
			if(preg_match($reg,$mail)){
				$m_where["user_mail"] = array("eq",$mail);
				$m_info = $this->get_member_info($m_where);
				if($m_info){
					$this->error = '该邮箱已绑定会员！';
					return false;
				}
				$info["new_email"] = $mail;
				$info["new_code"] = $rand;
				$info["new_code_time"] = $date;
			}else{
				$this->error = '您输入的邮箱格式有误,请重新核对后再输入！';
				return false;
			}
		}
		$resule = $this->where($where)->save($info);
		if($resule === false){
			$this->error = '发送邮件失败，请联系管理员！';
			return false;
		}
		//组装邮件内容
		$mail_content = HTMLContentForEmail(12,$business_info,$member_info);
		//发送邮件
		$res = postOffice($mail,$mail_content['subject'],$mail_content['body'],12);
		if($res["status"] == 1){
			$this->error = '发送邮件失败，请联系管理员！'.$res["message"];
			return false;
		}
		return true;
	}

	/**
	 * QQ第三方登录
	 * @date 2017年9月20日 下午5:16:55
	 * @author: Guopeng
	 * @return bool
	 */
	public function QQ_login(){
		session('openid_type',null);
		session('openid',null);
		$system = WebSiteConfig(6);
		$request = request();
		//应用的APPID
		$app_id = $system["login_qq_appid"];
		//应用的APPKEY
		$app_secret = $system["login_qq_appkey"];
		//成功授权后的回调地址
		$my_url = $system["login_qq_callback"];
		//Step1：获取Authorization Code
		$code = $request["code"];
		if(empty($code)){
			//state参数用于防止CSRF攻击，成功授权后回调时会原样带回
			$state = md5(uniqid(rand(),TRUE));
			session('qq_state',$state);
			//拼接URL
			$dialog_url = "https://graph.qq.com/oauth2.0/authorize?response_type=code&client_id=".$app_id."&redirect_uri=".urlencode($my_url)."&state=".$state;
			header("Location:$dialog_url");
		}
		//Step2：通过Authorization Code获取Access Token
		if($request['state'] == session('qq_state')){
			//拼接URL
			$token_url = "https://graph.qq.com/oauth2.0/token?grant_type=authorization_code&"."client_id=".$app_id."&redirect_uri=".urlencode($my_url)."&client_secret=".$app_secret."&code=".$code;
			$response = get_url_content($token_url);
			if(strpos($response,"callback") !== false){
				$lpos = strpos($response,"(");
				$rpos = strrpos($response,")");
				$response = substr($response,$lpos + 1,$rpos - $lpos - 1);
				$msg = json_decode($response);
				if(isset($msg->error)){
					$return["status"] = false;
					$return["msg"] = "QQ登录失败：".$msg->error.":".$msg->error_description;
					$return["url"] = U("login/login");
					return $return;
				}
			}
			//Step3：使用Access Token来获取用户的OpenID
			$params = array();
			parse_str($response,$params);
			$graph_url = "https://graph.qq.com/oauth2.0/me?access_token=".$params['access_token'];
			$str = get_url_content($graph_url);
			if(strpos($str,"callback") !== false){
				$lpos = strpos($str,"(");
				$rpos = strrpos($str,")");
				$str = substr($str,$lpos + 1,$rpos - $lpos - 1);
			}
			//$str = '{"openid":"A9C685D7F1AE8A9A3421F0"'.time().'}';
			$user = json_decode($str);
			if(isset($user->error)){
				$return["status"] = false;
				$return["msg"] = "QQ登录失败：".$user->error.":".$user->error_description;
				$return["url"] = U("login/login");
				return $return;
			}
			$openid = $user->openid;
			if(empty($openid)){
				$return["status"] = false;
				$return["msg"] = "QQ登录失败！";
				$return["url"] = U("login/login");
				return $return;
			}
			$info = $this->where(["qq_openid" => $user->openid])->find();
			session('qq_state',null);
			if(!empty($info)){
				/*验证用户状态*/
				if($info['user_state'] == 1){
					session('user_id',$info['user_id']);
					session('user_name',$info['user_name']);
					session('login_name',$info['login_name']);
					$return["status"] = true;
					$return["msg"] = "QQ登录成功！";
					$return["url"] = U("Member/index");
					return $return;
				}else{
					$return["status"] = false;
					$return["msg"] = "QQ登录失败：用户状态异常！";
					$return["url"] = U("login/login");
					return $return;
				}
			}else{
				session('openid_type',"QQ");
				session('openid',$openid);
				$return["status"] = false;
				$return["msg"] = false;
				$return["url"] = U("login/login");
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = "QQ登录失败：The state does not match. You may be a victim of CSRF.";
			$return["url"] = U("login/login");
			return $return;
		}
	}

	/**
	 * 微信第三方登录
	 * @date 2018年9月13日15:58:23
	 * @author: Guopeng
	 * @param $user
	 * @return bool
	 */
	public function wx_login($user){
		$info = $this->where(["wx_openid" => $user->openid])->find();
		if(!empty($info)){
			/*验证用户状态*/
			if($info['user_state'] == 1){
				session('user_id',$info['user_id']);
				session('user_name',$info['user_name']);
				session('login_name',$info['login_name']);
				return true;
			}else{
				$this->error = "该用户状态异常";
				return false;
			}
		}else{
			$this->error = false;
			return false;
		}
	}
	/********************登录控制器(LoginController)********************/
	/**
	 * 获取会员个人信息
	 * @date: 2016年10月25日 上午11:17:13
	 * @author: Lyubo
	 * @param: $where
	 * @return array
	 */
	public function get_member_info($where){
		return $this->where($where)->find();
	}

	/**
	 * 修改登录名
	 * @时间: 2019年2月13日11:20:55
	 * @author: GuoPeng
	 */
	public function modify_login_name(){
		$data = request();
		$login_name = $data["login_name"];
		$password = $data["password"];
		$user_id = session("user_id");
		$user = $this->where(array("user_id"=>$user_id))->find();
		if(!$user){
			$return["status"] = false;
			$return["msg"] = array("name"=>"请先登录！","psd"=>"");
			return $return;
		}
		if($user["user_pass"] != pwd($user["login_name"],md5($password))){
			$return["status"] = false;
			$return["msg"] = array("name"=>"","psd"=>"密码错误，请重新输入！");
			return $return;
		}
		if(($user["qq_openid"] || $user["wx_openid"]) && preg_match('/^(qq|wx)[0-9]{10}$/',$user["login_name"])){
			if($login_name){
				$user_info = $this->where(array("login_name" => $login_name))->find();
				if($user_info){
					$return["status"] = false;
					$return["msg"] = array("name"=>"登录名已存在，请重新输入！","psd"=>"");
					return $return;
				}
				$user_pass = pwd($login_name,md5($password));
				$res = $this->where(array("user_id" => $user_id))->save(array("login_name" => $login_name,"user_pass" => $user_pass));
				if($res !== false){
					$return["status"] = true;
					$return["msg"] = array("name"=>"","psd"=>"");
					return $return;
				}else{
					$return["status"] = false;
					$return["msg"] = array("name"=>"登录名修改失败！","psd"=>"");
					return $return;
				}
			}else{
				$return["status"] = false;
				$return["msg"] = array("name"=>"请输入登录名！","psd"=>"");
				return $return;
			}
		}else{
			$return["status"] = false;
			$return["msg"] = array("name"=>"非QQ/微信自动注册，不可修改登录名！","psd"=>"");
			return $return;
		}
	}

	/**
	 * 修改会员密码
	 * @date: 2016年11月1日 下午5:01:54
	 * @author: Lyubo
	 * @return bool
	 */
	public function member_modify_pass($data){
		$login_name = session("login_name");
		$ecode = clearXSS(I("post.ecode"));
		$user_pass = clearXSS(I("post.user_pass"));
		$user_pass2 = clearXSS(I("post.user_pass2"));
		/*修改密码的逻辑*/
		if(strlen($ecode) !== 6){
			$this->error = '验证码错误！';
			return false;
		}
		if(!passwordIsStrong($user_pass)){
			$this->error = '密码必须是6到20位数字、字母或特殊字符组成！';
			return false;
		}
		if($user_pass != $user_pass2){
			$this->error = '确认密码和新密码不一致！';
			return false;
		}
		$map["login_name"] = array("eq",$login_name);
//		$old_pass= pwd($login_name,md5($old_pass));
		$info = $this->where($map)->find();//先用旧密码查询是否存在会员
		/*if ($old_pass != $info['user_pass']){
			$this->error = '原密码错误';
			return false;
		}*/
		$code_time = strtotime($info['code_time']) + 30 * 60;
		if($code_time <= time()){
			$this->error = '验证码已过期，请重新发送验证码！';
			return false;
		}
		if($ecode != $info['code']){
			$this->error = '验证码错误！';
			return false;
		}
		$upd_info["code"] = 0;
		$upd_info["user_pass"] = pwd($login_name,md5($user_pass));
		$where["login_name"] = array("eq",$login_name);
		//会员存在进行修改密码
		$res = $this->where($where)->save($upd_info);
		if($res === false){
			$this->error = '服务器繁忙，请重试！';
			return false;
		}else{
			return $res;
		}
	}

	/**
	 * 修改会员信息
	 * @date: 2016年11月2日 上午11:21:53
	 * @author: Lyubo
	 * @param: $where
	 * @return boolean
	 */
	public function member_modify_info($where){
		$this->_validate = [
			['user_name','require','请填写用户名！'],
			["user_name","1,10","姓名最大长度10！",2,"length"],
			['user_mail','require','请填写邮箱！'],
			['user_mail','email','请填写真实有效的邮箱！'],
			['user_code','require','请填写身份证号码！'],
			['user_mobile','require','请填写手机号码！'],
			['user_mobile','/^1[3|4|5|7|8][0-9]\d{8}$/','请正确填写您的手机号码！',2,"regex"],
			["user_mobile","11","手机号码不能小于11个数字！",2,"length"],
		];
		$member_info = request(true);
		$user_info = $this->where(array("user_name"=>$member_info["user_name"]))->find();
		if($user_info){
			$this->error = '该用户名已存在，请重新填写！';
			return false;
		}
		if($this->create()){
			if(!checkIdCard($member_info["user_code"])){
				$this->error = "请正确填写您的身份证号号码!";
				return false;
			}
			return $result = $this->where($where)->save($member_info);
		}else{
			return false;
		}
	}

	public function ywcount($user_id){
		$where["bs.user_id"] = $user_id;
		$vps_count = $this->query_count("vps_business",$where);
		$count["vps"] = $vps_count;
		$fast_vps_count = $this->query_count("fast_vps_business",$where);
		$count["fvps"] = $fast_vps_count;
		$cloudserver_count = $this->query_count("cloudserver_business",$where);
		$count["ffwq"] = $cloudserver_count;
		$cloudspace_count = $this->query_count("cloudspace_business",$where);
		$count["ykj"] = $cloudspace_count;
		$clouddb_count = $this->query_count("clouddb_business",$where);
		$count["fsjk"] = $clouddb_count;
		$cloudserver_business_ip_count = $this->query_count("cloudserver_business_ip",$where);
		$count["fip"] = $cloudserver_business_ip_count;
		$ssl_count = $this->query_count("ssl_business",$where);
		$count["ssl"] = $ssl_count;
		$domain_count = $this->query_count("domain_business",$where);
		$count["ym"] = $domain_count;
		$cloudstorage_count = $this->query_count("cloudstorage_business",$where);
		$count["cc"] = $cloudstorage_count;
		$where["bs.virtual_type"] = array("in","0,4");
		$gn_virtualhost_count = $this->query_count("virtualhost_business",$where);
		$count["gnzj"] = $gn_virtualhost_count;
		$where["bs.virtual_type"] = 1;
		$hk_virtualhost_count = $this->query_count("virtualhost_business",$where);
		$count["hkzj"] = $hk_virtualhost_count;
		$where["bs.virtual_type"] = 2;
		$usa_virtualhost_count = $this->query_count("virtualhost_business",$where);
		$count["usazj"] = $usa_virtualhost_count;
		$where["bs.virtual_type"] = 3;
		$yun_virtualhost_count = $this->query_count("virtualhost_business",$where);
		$count["yunzj"] = $yun_virtualhost_count;
		$count["dxf"] = $this->get_overdue_business_count($user_id);
		return $count;
	}

	/**
	 * 获取临近$days的所有业务
	 * @时间: 2016年11月24日 上午11:33:55
	 * @author: duanbin
	 * @param: variable
	 * @return: type
	 */
	protected function get_overdue_business_count($user_id,$days = 30){
		$where["bs.user_id"] = $user_id;
		$where['_string'] = 'bs.overdue_time between now() and date_add(now(), INTERVAL '.$days.' day)';
		$vh = $this->query_count("virtualhost_business",$where);
		$fvps = $this->query_count("fast_vps_business",$where);
		$vps = $this->query_count("vps_business",$where);
		$cs = $this->query_count("cloudserver_business",$where);
		$cd = $this->query_count("clouddb_business",$where);
		$ip = $this->query_count("cloudserver_business_ip",$where);
		$cp = $this->query_count("cloudspace_business",$where);
		$sb = $this->query_count("ssl_business",$where);
		$db = $this->query_count("domain_business",$where);
		$all_bs_count = $vh + $fvps + $vps + $cs + $ip + $cp + $cd + $sb + $db;
		return $all_bs_count;
	}

	protected function query_count($table,$where){
		$query = M($table);
		$query_count = $query->alias(' bs ')->join('left join '.C('DB_PREFIX').'product as p on p.id = bs.product_id')
			 ->join('inner join '.C('DB_PREFIX').'product_type as pt on p.product_type_id= pt.id ')
			 ->where($where)->count();//返回带条件的总记录数
		return $query_count;
	}

	public function get_member_money(){
		$where["m.user_id"] = array("eq",session("user_id"));
		$member_info = $this->alias('m')
			->field("m.user_id,m.user_name,m.login_name,ma.balance,ma.purchases,m.password_level,r.region_name as level")
			->join('left join '.C('DB_PREFIX').'member_account as ma on ma.user_id = m.user_id')
			->join('left join '.C('DB_PREFIX').'region as r on r.region_code = m.user_level AND r.state="2"')
			->where($where)->find();
		$arr = explode(".",$member_info["balance"]);
		if(!$arr[0]){
			$arr[0] = 0;
		}
		if(!$arr[1]){
			$arr[1] = "00";
		}
		$member_info["balance"] = $arr;
		$arr = explode(".",$member_info["purchases"]);
		if(!$arr[0]){
			$arr[0] = 0;
		}
		if(!$arr[1]){
			$arr[1] = "00";
		}
		$member_info["purchases"] = $arr;
		return $member_info;
	}

	/**
	 * 修改绑定邮箱
	 * @date: 2017年7月5日 上午11:41:54
	 * @author: Guopeng
	 * @return bool
	 */
	public function member_modify_mail(){
		$data = request();
		$bind_mail = $data["bind_mail"] + 0;
		$login_name = session("login_name");
		$map["login_name"] = array("eq",$login_name);
		$info = $this->where($map)->find();//先查询是否存在会员
		if(!$info){
			$this->error = '该会员不存在，请重新登录！';
			return false;
		}
		$new_email = $data["new_email"];
		$ncode = clearXSS(I("post.new_email_code"));
		if($new_email != $info['new_email']){
			$this->error = '邮箱错误，请核对邮箱填写是否正确！';
			return false;
		}
		if(strlen($ncode) !== 6){
			$this->error = '新邮箱验证码错误！';
			return false;
		}
		$new_code_time = strtotime($info['new_code_time']) + 30 * 60;
		if($new_code_time <= time()){
			$this->error = '新邮箱验证码已过期，请重新发送验证码！';
			return false;
		}
		if($ncode != $info['new_code']){
			$this->error = '新邮箱验证码错误！';
			return false;
		}
		if($bind_mail != 1){
			$code_time = strtotime($info['code_time']) + 30 * 60;
			if($code_time <= time()){
				$this->error = '验证码已过期，请重新发送验证码！';
				return false;
			}
			$ecode = clearXSS(I("post.email_code"));
			if(strlen($ecode) !== 6){
				$this->error = '验证码错误！';
				return false;
			}
			if($ecode != $info['code']){
				$this->error = '验证码错误！';
				return false;
			}
		}
		$upd_info["code"] = 0;
		$upd_info["new_code"] = 0;
		$upd_info["new_email"] = "";
		$upd_info["user_mail"] = $new_email;
		$res = $this->where($map)->save($upd_info);
		if($res === false){
			$this->error = '服务器繁忙，请重试！';
			return false;
		}else{
			return $res;
		}
	}

	/**
	 * 绑定QQ
	 * @date 2018年9月12日16:26:14
	 * @author: Guopeng
	 * @param $user
	 * @param $user_info
	 * @return bool
	 */
	public function bind_qq($user,$user_info){
		$info = $this->where(["qq_openid" => $user->openid])->find();
		if(!empty($info)){
			$this->error = "该QQ账号已绑定会员！";
			return false;
		}else{

			$where["user_id"] = $user_info["user_id"];
			$data["qq_openid"] = $user->openid;
			$res = $this->where($where)->save($data);
			if($res !== false){
				return true;
			}else{
				$this->error = "绑定QQ账号失败！";
				return false;
			}
		}
	}

	/**
	 * 绑定微信
	 * @date 2018年9月13日15:58:34
	 * @author: Guopeng
	 * @param $user
	 * @param $user_info
	 * @return bool
	 */
	public function bind_wx($user,$user_info){
		$info = $this->where(["wx_openid" => $user->openid])->find();
		if(!empty($info)){
			$this->error = "该微信账号已绑定会员！";
			return false;
		}else{
			$where["user_id"] = $user_info["user_id"];
			$data["wx_openid"] = $user->openid;
			$res = $this->where($where)->save($data);
			if($res !== false){
				return true;
			}else{
				$this->error = "绑定微信账号失败！";
				return false;
			}
		}
	}

	/**
	 * 获取会员级别信息
	 * @date: 2017年12月11日10:27:26
	 * @author: Guopeng
	 * @param $user_id
	 * @param $ptype_id
	 * @return mixed
	 */
	function get_user_level($user_id,$ptype_id){
		$where["m.user_id"] = $user_id;
		$where["l.product_type_id"] = $ptype_id;
		$field = "r.region_name as name,r.region_code as level,l.discount as discount";
		$join1 = "left join agent_region as r on m.user_level = r.region_code";
		$join2 = "left join agent_user_level as l on r.id = l.region_id";
		$user_level = $this->alias("m")->field($field)->where($where)->join($join1)->join($join2)->find();
		return $user_level;
	}
}