<?php
namespace Frontend\Model;

use Common\Data\StateData as SD;
use Common\Model\CertifyLogModel;
use Frontend\Model\BusinessModel;
use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;

class TemplateModel extends BusinessModel{
	protected $trueTableName = 'agent_domain_template';

	public function conver_par(){
		$date = request();
		$where["bs.uid"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$select = clearXSS($date['select']);
			$map['bs.model_name'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['bs.contact_id'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map["bs.beizhu"] = array("like","%$select%");
			$where['_complex'] = $map;
		}
		return $where;
	}

	/**
	 * 分页
	 * @date: 2019年2月20日11:22:08
	 * @author: GuoPeng
	 * @param $where
	 * @param int $per_page
	 * @param string $field
	 * @param string $order_by
	 * @return array
	 */
	public function paging($where,$per_page = 10,$field = "*",$order_by = "create_time DESC"){
		$sumpage = [];
		$count = $this->alias('bs')->field($field)->where($where)->order($order_by)->count();
		$Page = new \Think\Page($count,$per_page);// 实例化分页类 传入总记录数和每页显示的记录数
		$Page->setConfig('prev','上一页');
		$Page->setConfig('next','下一页');
		$Page->setConfig("first","首页");
		$Page->setConfig("last","尾页");
		$request = request();
		//分页跳转的时候保证查询条件
		foreach($request as $key => $val){
			$Page->parameter[$key] = urlencode($val);
		}
		$sumpage['page'] = $Page;
		$sumpage['count'] = $count;
		return $sumpage;
	}

	/**
	 * 获取域名模板数据
	 * @date: 2019年2月20日11:08:04
	 * @author: GuoPeng
	 * @return int|mixed
	 */
	public function gat_template_list(){
		$where = $this->conver_par();
		$per_page = 10;
		$field = "*";
		$order = I("get.order");
		$order = $order == "ASC" ? "ASC" : "DESC";
		$order_by = "create_time {$order}";
		$info = [];
		$sum = $this->paging($where,$per_page,$field,$order_by);
		$data = $this->alias('bs')->field($field)->where($where)->order($order_by)->limit($sum['page']->firstRow.','.$sum['page']->listRows)->select();
		$info['count'] = $sum['count'];
		$info['show'] = $sum['page']->show();
		//对自带thinkphp分页进行替换
		$show = str_replace("<div>","",$info["show"]);
		$show = str_replace("</div>","",$show);
		$show = str_replace("span","a",$show);
		$info['page_show'] = $show;
		$info['list'] = $data;
		return $info;
	}

	/**
	 * 创建域名模板
	 * @date: 2019年2月22日10:55:33
	 * @author: GuoPeng
	 * @return: array
	 */
	public function template_add(){
		$data = request(true);
		//验证联系人信息
		$var_code = $this->template_contact($data);
		if($var_code["status"] === false){
			return $var_code;
		}
		$save = $var_code["msg"];
		//封装联系人参数
		if($save["owner_type"] == 1){
			$contact["ownerXing"] = $save["owner_xing_zh"];//域名所有者姓（域名类型为1需要）
			$contact["ownerMing"] = $save["owner_ming_zh"];//域名所有者名（域名类型为1需要）
		}else{
			$contact["ownerZh"] = $save["owner_zh"];//公司名（域名类型为2需要）
		}
		$contact["ownerType"] = $save["owner_type"];//域名类型：1：个人，2：企业
		$contact["input_name"] = $save["registrar_type"];//注册商:5：中国数据，100012：西部数码，100014：万网（新）
		$contact["ownerlnZh"] = $save["owner_ln_zh"];//联系人姓
		$contact["ownerFnZh"] = $save["owner_fn_zh"];//联系人名
		$contact["ownerProvinceZh"] = $save["owner_province_zh"];//所有者省
		$contact["ownerCityZh"] = $save["owner_city_zh"];//所有者市
		$contact["ownerStreetZh"] = $save["owner_street_zh"];//所有者街道地址
		$contact["ownerZip"] = $save["owner_zip"];//所有者邮编
		$contact["ownerEmail"] = $save["owner_email"];//所有者邮箱 万网的要先验证
		$contact["ownerTelN"] = $save["owner_telC"]."-".$save["owner_telA"]."-".$save["owner_telN"];//所有者电话号码:国际区号-国内区号-电话
		$contact['ownerFaxN'] = $save['owner_faxC']."-".$save['owner_faxA']."-".$save['owner_faxN'];//所有者传真号码:国际区号-国内区号-传真
		$api_config = WebSiteConfig(2);//获取网站配置
		$api_access = $api_config["api_access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$uid = $save['uid'] = session("user_id");
		$save['state'] = 0;
		$save['sm_state'] = 0;
		$save['create_time'] = date("Y-m-d H:i:s");
		$ptype = GD::PTYPE_DOMAIN;
		$pname = "createmodel";
		$tid = GD::TID_DOMAIN;
		$log_contact = "";
		foreach($contact as $key=>$val){
			$log_contact .= "-{$key}:{$val}";
		}
		$log_info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}{$log_contact}";
		/**调用接口，域名注册*/
		try{
			$result = $transaction->domain_create_model($contact);
			api_log($uid,$log_info,$result,"创建域名模板");
		}catch(\Exception $e){
			api_log($uid,$log_info,$e->getMessage(),"创建域名模板失败-接口调用失败");
			$return["msg"] = business_code(-9);
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] !== 0){
			$return["msg"] = business_code($xstr['code']);
			$return["status"] = false;
			return $return;
		}
		$save["contact_id"] = $xstr["info"]["modelid"];
		//添加域名模板信息
		$res = $this->add($save);
		if($res !== false){
			$return["status"] = true;
			return $return;
		}else{
			$return["msg"] = "域名模板创建成功，数据添加失败";
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 验证域名模板信息
	 * @date: 2019年2月25日09:43:05
	 * @author: GuoPeng
	 * @param $data
	 * @return bool|int
	 */
	public function template_contact($data){
		$save["owner_type"] = $data["owner_type"] + 0;//域名类型：1：个人，2：企业
		$save["registrar_type"] = $data["registrar_type"] + 0;//注册商:5：中国数据，100012：西部数码，100014：万网（新）
		if($save["owner_type"] == 1){
			$save["owner_xing_zh"] = str_replace(" ","",$data["owner_xing_zh"]);//域名所有者姓（域名类型为1需要）
			$save["owner_ming_zh"] = str_replace(" ","",$data["owner_ming_zh"]);//域名所有者名（域名类型为1需要）
			$save["owner_zh"] = $save["owner_xing_zh"].$save["owner_ming_zh"];//公司名（域名类型为2需要）
			$save['owner_xing'] = $data['owner_xing'];//域名所有者姓（英文）
			$save['owner_ming'] = $data['owner_ming'];//域名所有者名（英文）
			$save['owner'] = $save['owner_xing'].$save['owner_ming'];//公司名（英文）
		}else{
			$save["owner_xing_zh"] = "";//域名所有者姓（域名类型为1需要）
			$save["owner_ming_zh"] = "";//域名所有者名（域名类型为1需要）
			$save["owner_zh"] = str_replace(" ","",$data["owner_zh"]);//公司名（域名类型为2需要）
			$save['owner_xing'] = "";//域名所有者姓（英文）
			$save['owner_ming'] = "";//域名所有者名（英文）
			$save['owner'] = $data['owner'];//公司名（英文）
		}
		$save["owner_ln_zh"] = str_replace(" ","",$data["owner_ln_zh"]);//联系人姓
		$save["owner_fn_zh"] = str_replace(" ","",$data["owner_fn_zh"]);//联系人名
		$save["owner_province_zh"] = str_replace(" ","",$data["owner_province_zh"]);//所有者省
		$save["owner_city_zh"] = str_replace(" ","",$data["owner_city_zh"]);//所有者市
		$save["owner_street_zh"] = str_replace(" ","",$data["owner_street_zh"]);//所有者街道地址
		$save["owner_zip"] = $data["owner_zip"];//所有者邮编
		$save["owner_email"] = $data["owner_email"];//所有者邮箱 万网的要先验证
		$save["owner_telC"] = $data["owner_telC"];//所有者电话号码:国际区号
		$save["owner_telA"] = $data["owner_telA"];//所有者电话号码:国内区号
		$save["owner_telN"] = $data["owner_telN"];//所有者电话号码:电话
		$save['owner_faxC'] = $data['owner_faxC'];//所有者传真号码:国际区号
		$save['owner_faxA'] = $data['owner_faxA'];//所有者传真号码:国内区号
		$save['owner_faxN'] = $data['owner_faxN'];//所有者传真号码:传真
		$save['model_name'] = $save["owner_zh"];//模板名
		$save['owner_country'] = "CN";//联系人国家
		$save['owner_ln'] = $data['owner_ln'];//联系人姓（英文）
		$save['owner_fn'] = $data['owner_fn'];//联系人名（英文）
		$save['owner_province'] = $data['owner_province'];//联系人省（英文）
		$save['owner_city'] = $data['owner_city'];//联系人市（英文）
		$save['owner_street'] = $data['owner_street'];//联系人街道地址（英文）
		// 公司名
		$gongsi = "/^(([\x{4e00}-\x{9fa5}]+\（[\x{4e00}-\x{9fa5}]+\）[\x{4e00}-\x{9fa5}]*)|([\x{4e00}-\x{9fa5}])){4,64}$/u";
		// 姓名
		$xingming = "/^[\x{4e00}-\x{9fa5}]{1,20}$/u";
		// 省份&城市
		$province = "/^[\x{4e00}-\x{9fa5}]{1,32}$/u";
		// 地址
		$street = "/^[\x{4e00}-\x{9fa5}a-zA-z0-9]{2,64}$/u";
		// 名字(英文)
		$xingmingen = "/^[a-zA-Z]{1,25}$/";
		// 公司名(英文)
		$gongsien = "/^[a-zA-Z]{4,150}$/";
		// 省份&城市(英文)
		$provinceen = "/^[a-zA-Z]{2,64}$/";
		// 地址(英文)
		$streeten = "/^[0-9a-zA-Z]{2,150}$/";
		// 邮政编码
		$ZipCode = "/^\d{6}$/";
		// 国际区号
		$gjqh = "/^\d{2,3}$/";
		// 国内区号
		$gnqh = "/^0|0\d{2,3}$/";
		// 电话
		$phone = "/^((1[35847]\d{9})|\d{7,14}(-\d{3,})?)$/";
		// 邮箱正则表达式
		$email = "/[A-Za-z0-9]+@([_A-Za-z0-9]+\\.)+[A-Za-z0-9]{2,3}/";
		if(!in_array($save["owner_type"],array(1,2))){
			$return["msg"] = "域名类型错误！";
			$return["status"] = false;
			return $return;
		}
		if(!in_array($save["registrar_type"],array(5,100012,100014))){
			$return["msg"] = "注册商类型错误！";
			$return["status"] = false;
			return $return;
		}
		if($save["owner_type"] == 1){
			//域名所有者姓
			if(!preg_match($xingming,$save["owner_xing_zh"])){
				$return["msg"] = "域名所有者姓格式错误！";
				$return["status"] = false;
				return $return;
			}
			//域名所有者名
			if(!preg_match($xingming,$save["owner_ming_zh"])){
				$return["msg"] = "域名所有者名格式错误！";
				$return["status"] = false;
				return $return;
			}
		}else{
			//域名所有者
			if(!preg_match($gongsi,$save["owner_zh"])){
				$return["msg"] = "域名所有者格式错误！";
				$return["status"] = false;
				return $return;
			}
		}
		//域名联系人姓
		if(!preg_match($xingming,$save["owner_ln_zh"])){
			$return["msg"] = "域名联系人姓格式错误！";
			$return["status"] = false;
			return $return;
		}
		//域名联系人名
		if(!preg_match($xingming,$save["owner_fn_zh"])){
			$return["msg"] = "域名联系人名格式错误！";
			$return["status"] = false;
			return $return;
		}
		//域名联系人省份
		if(!preg_match($province,$save["owner_province_zh"])){
			$return["msg"] = "域名联系人省份格式错误！";
			$return["status"] = false;
			return $return;
		}
		//域名联系人城市
		if(!preg_match($province,$save["owner_city_zh"])){
			$return["msg"] = "域名联系人城市格式错误！";
			$return["status"] = false;
			return $return;
		}
		//域名联系人地址
		if(!preg_match($street,$save["owner_street_zh"])){
			$return["msg"] = "域名联系人地址格式错误！";
			$return["status"] = false;
			return $return;
		}
		//邮政编码
		if(!preg_match($ZipCode,$save["owner_zip"])){
			$return["msg"] = "邮政编码格式错误！";
			$return["status"] = false;
			return $return;
		}
		//电话国际区号
		if(!preg_match($gjqh,$save["owner_telC"])){
			$return["msg"] = "电话格式错误1！";
			$return["status"] = false;
			return $return;
		}
		//电话国内区号
		if(!preg_match($gnqh,$save["owner_telA"])){
			$return["msg"] = "电话格式错误！";
			$return["status"] = false;
			return $return;
		}
		//电话
		if(!preg_match($phone,$save["owner_telN"])){
			$return["msg"] = "电话格式错误！";
			$return["status"] = false;
			return $return;
		}
		//传真国际区号
		if(!preg_match($gjqh,$save["owner_faxC"])){
			$return["msg"] = "传真格式错误1！";
			$return["status"] = false;
			return $return;
		}
		//传真国内区号
		if(!preg_match($gnqh,$save["owner_faxA"])){
			$return["msg"] = "传真格式错误2！";
			$return["status"] = false;
			return $return;
		}
		//传真
		if(!preg_match($phone,$save["owner_faxN"])){
			$return["msg"] = "传真格式错误！";
			$return["status"] = false;
			return $return;
		}
		//电子邮箱
		if(!preg_match($email,$save["owner_email"])){
			$return["msg"] = "电子邮箱格式错误！";
			$return["status"] = false;
			return $return;
		}
		$return["msg"] = $save;
		$return["status"] = true;
		return $return;
	}

	/**
	 * 删除域名模板
	 * @date: 2019年2月25日17:30:17
	 * @author: GuoPeng
	 * @return bool
	 */
	public function template_delete(){
		$data = request();
		$id = $data["id"] + 0;//域名模板ID
		$res = $this->where(array("id"=>$id))->delete();
		if($res !== false){
			$return["msg"] = "域名模板删除成功！";
			$return["status"] = true;
			return $return;
		}else{
			$return["msg"] = "域名模板删除失败！";
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 域名模板备注修改
	 * @date: 2019年2月25日17:30:17
	 * @author: GuoPeng
	 * @return bool
	 */
	public function template_remark_edit(){
		$data = request();
		$id = $data["id"] + 0;//域名模板ID
		$where["uid"] = session('user_id');
		$where["id"] = $id;
		$save['beizhu'] = $data['remark'];
		$res = $this->where($where)->save($save);
		if($res !== false){
			$return["msg"] = "域名模板备注修改成功！";
			$return["status"] = true;
			return $return;
		}else{
			$return["msg"] = "域名模板备注修改失败！";
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 获取域名模板详情
	 * @date: 2019年2月27日14:31:03
	 * @author: GuoPeng
	 * @return bool
	 */
	public function get_template_info(){
		$data = request();
		$id = $data["id"] + 0;//域名模板ID
		$where["uid"] = session('user_id');
		$where["id"] = $id;
		$res = $this->where($where)->find();
		if($res){
			$return["msg"] = $res;
			$return["status"] = true;
			return $return;
		}else{
			$return["msg"] = "该域名模板不存在！";
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 域名模板实名认证
	 * @date: 2019年2月25日17:32:35
	 * @author: GuoPeng
	 * @param bool $m true：获取信息，false：操作
	 * @return int|mixed
	 */
	public function toAuthentication($m){
		$data = request();
		$id = $data["id"];
		$user_id = session("user_id");
		$binfo = $this->where(array("id" => $id,"user_id"=>$user_id))->find();
		if(!$binfo){
			$return["msg"] = "未查询到符合条件的业务";
			$return["status"] = false;
			return $return;
		}
		/*同步域名业务*/
		$Respository = new \Common\Respository\DomainRespository($this);
		$result = $Respository->DomainBusinessSynchronizing($binfo["api_bid"]);
		/*同步后，查看实名状态*/
		$binfo = $this->where(array("id" => $id))->find();//实名状态查询-1未实名 0:已实名 1:审核中 2:审核拒绝 3:实名失败 4:实名异常 5:等待上报 6.资料未提交
		if(!in_array($binfo["authentication"],array(-1,2,3))){ //已实名
			$return["msg"] = "该业务已经提交实名认证，请勿重复提交";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$return["info"] = $binfo;
			$return["status"] = true;
			return $return;
		}
		$provider = array("中国数据"=>5,"西部数码"=>100012,"万网（新）"=>100014);
		$par["ptype"] = $ptype = "domain";
		$par["pname"] = $pname = "realnamedomain";
		$par["tid"] = $tid = "15";
		$par["domainname"] = $domain_name = $binfo["domain_name"];
		$par["input_name"] = $jkbh = $provider[$binfo["provider"]];//注册商类型(5:中国数据,100012:西部数码,100014:万网（新）)
		$par["ownerType"] = $ownerType = $data["ownerType"];//域名类型(1:个人，2:企业)
		$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-domainname:{$domain_name}-input_name:{$jkbh}-ownerType:{$ownerType}";
		$idcart = "/^[a-zA-Z0-9]{8,18}$/";//身份证件验证
		$orgCart = "/^[a-zA-Z0-9]{15,25}$/";//企业证件验证
		$regDWMC = "/^[\x{4e00}-\x{9fa5}]{2,64}$/u";
		if($jkbh == 100012){
			$par["applyName"] = $applyName = $data["applyName"];
			if(!preg_match($regDWMC,str_replace(" ","",$applyName))){
				$return["msg"] = "联系人格式错误（2-64个中文字符）！";
				$return["status"] = false;
				return $return;
			}
			$info .= "-applyName:{$applyName}";
		}
		if(!in_array($ownerType,array(1,2))){
			$return["msg"] = "实名类型错误！";
			$return["status"] = false;
			return $return;
		}
		$idtype = $data["idtype"] + 0;//注册人/联系人证件类型
		$idcode = str_replace(" ","",clearXSS(I("post.")["idcode"]));//注册人/联系人证件号码
		if(!in_array($idtype,array(1,5,6,11,12,27,29))){
			$return["msg"] = "注册人/联系人个人证件类型错误！";
			$return["status"] = false;
			return $return;
		}
		if(!preg_match($idcart,$idcode)){
			$return["msg"] = "注册人/联系人个人证件号码格式错误！";
			$return["status"] = false;
			return $return;
		}
		$par["idtype"] = $idtype;
		$par["idcode"] = $idcode;
		$idCard = $_FILES["idCard"];
		$par["idimgname"] = $idimgname = $idCard["name"];//图片名称(.jpg格式)
		$info .= "-idtype:{$idtype}-idcode:{$idcode}-idimgname:{$idimgname}";
		//验证上传的图片信息
		if(empty($idCard["tmp_name"])){
			$return["msg"] = "请上传注册人/联系人个人证件正面扫描件！";
			$return["status"] = false;
			return $return;
		}
		//验证图片上传大小
		if($idCard["size"] > 1024*1024 || $idCard["size"] < 55*1024){
			$return["msg"] = "上传注册人/联系人个人证件正面扫描件大小应为55KB-1MB！";
			$return["status"] = false;
			return $return;
		}
		if(!in_array(explode("/",$idCard["type"])[1],array("jpg","jpeg"))){
			$return["msg"] = "上传注册人/联系人个人证件正面扫描件类型应为JPG/JPEP格式！";
			$return["status"] = false;
			return $return;
		}
		$img = $idCard["tmp_name"];
		$image_data = fread(fopen($img,"r"),filesize($img));
		$idimgFile = base64_encode($image_data);
		if(empty($idimgFile)){
			$return["msg"] = "未获取到个人证件扫描件，请重新上传！";
			$return["status"] = false;
			return $return;
		}
		$par["idimgFile"] = $idimgFile;//base64(.jpg格式)图片
		if($ownerType == 2){
			$orgprooftype = $data["orgprooftype"] + 0;//组织(企业)证件类型(企业类型必传)
			$orgcode = str_replace(" ","",clearXSS(I("post.")["orgcode"]));//组织(企业)证件号码(企业类型必传)
			if(!in_array($orgprooftype,array(1,2,3,4))){
				$return["msg"] = "组织(企业)证件类型错误！";
				$return["status"] = false;
				return $return;
			}
			if(!preg_match($orgCart,$orgcode)){
				$return["msg"] = "组织(企业)证件号码格式错误！";
				$return["status"] = false;
				return $return;
			}
			$par["orgprooftype"] = $orgprooftype;
			$par["orgcode"] = $orgcode;
			$orgCard = $_FILES["orgCard"];
			$par["orgimgname"] = $orgimgname = $orgCard["name"];//图片名称(.jpg格式)
			$info .= "-orgprooftype:{$orgprooftype}-orgcode:{$orgcode}-orgimgname:{$orgimgname}";
			//验证上传的图片信息
			if(empty($orgCard["tmp_name"])){
				$return["msg"] = "请上传组织(企业)证件扫描件！";
				$return["status"] = false;
				return $return;
			}
			//验证图片上传大小
			if($orgCard["size"] > 1024*1024 || $orgCard["size"] < 55*1024){
				$return["msg"] = "上传组织(企业)证件扫描件大小应为55KB-1MB！";
				$return["status"] = false;
				return $return;
			}
			if(!in_array(explode("/",$orgCard["type"])[1],array("jpg","jpeg"))){
				$return["msg"] = "上传组织(企业)证件扫描件类型应为JPG/JPEP格式！";
				$return["status"] = false;
				return $return;
			}
			$img = $orgCard["tmp_name"];
			$image_data = fread(fopen($img,"r"),filesize($img));
			$orgimgFile = base64_encode($image_data);
			if(empty($orgimgFile)){
				$return["msg"] = "未获取到上传扫描件，请重新上传！";
				$return["status"] = false;
				return $return;
			}
			$par["orgimgFile"] = $orgimgFile;//base64(.jpg格式)图片
		}
		$api_access = $binfo["access"] ? $binfo["access"] : 1;


		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		try{
			$result = $transaction->real_name_domain($par);
			api_log($user_id,$info,$result,"{$domain_name}提交域名实名认证信息");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"{$domain_name}提交域名实名认证信息-失败");
			$return["msg"] = business_code(-9);
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr["code"] == 0 && $xstr["code"] !== null){
			$detail = $xstr["info"];
			if(empty($detail)){
				/*实名接口调用成功，生成实名记录,并修改代理平台上的实名状态为审核中*/
				$certify_log["user_id"] = $user_id;
				$certify_log["certify_time"] = date("Y-m-d H:i:s");
				$certify_log["check_status"] = 1;
				$certify_log["idCart"] = $par["idcode"];
				$certify_log["product"] = $binfo["domain_name"];
				$certify_log["pb_id"] = $binfo["id"];
				$certify_log["api_bid"] = $binfo["api_bid"];
				$certify_log["phone"] = "";
				$certify_log["contactname"] = $par["applyName"];
				$certify_log["comptype"] = $par["ownerType"];
				$certify_log["mark"] = "审核中";
				M("certify_log")->add($certify_log);
				$this->where(array("id"=>$id))->save(array("authentication"=>1));
				$return["msg"] = "域名实名认证信息提交成功，请等待审核！";
				$return["status"] = true;
				return $return;
			}else{
				$return["msg"] = $xstr["info"][0]["failinfo"] ? $xstr["info"][0]["failinfo"] : "域名实名认证信息提交失败";
				$return["status"] = false;
				return $return;
			}
		}else{
			$return["msg"] = business_code($xstr["code"]);
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 域名实名认证记录查询
	 * @date: 2018年12月11日18:11:59
	 * @author: Guopeng
	 * @return int|mixed
	 */
	public function auth_list(){
		$data = request();
		$user_id = session("user_id");
		$certifylog = new CertifyLogModel();
		if(isset($data["id"])){
			$id = $data["id"]+0;
			$binfo = $this->where(array("id" => $id,"user_id"=>$user_id))->find();
			if(!$binfo){
				$return["msg"] = "未查询到符合条件的业务！";
				$return["status"] = false;
				return $return;
			}
			$where["user_id"] = $user_id;
			$where["pb_id"] = $id;
			$where["api_bid"] = $binfo["api_bid"];
			$where["product"] = $binfo["domain_name"];
		}else{
			$where["user_id"] = $user_id;
		}
		$info = $certifylog->get_log_list($where,10,"*","");
		foreach($info["list"] as $k => &$v){
			$v["idcart"] = substr_replace($v["idcart"],"*******",4,12);
			$v["contactname"] = mb_substr($v["contactname"],0,1,'utf-8')."**";
		}
		/*审核状态如何判定，及审核说明情况 */
		return $info;
	}
}